package java.text;

final class CharacterBreakData extends TextBoundaryData {
   private static final byte accent_diacritic = 0;
   private static final byte baseForm = 1;
   private static final byte baseCR = 2;
   private static final byte baseLF = 3;
   private static final byte choseong = 4;
   private static final byte jungseong = 5;
   private static final byte jongseong = 6;
   private static final byte EOS = 7;
   private static final int COL_COUNT = 8;
   // $FF: renamed from: SI byte
   private static final byte field_0 = -128;
   private static final byte STOP = 0;
   private static final byte SI_STOP = -128;
   private static final byte[] kCharacterForwardData = new byte[]{0, 0, 0, 0, 0, 0, 0, 0, -126, -126, -125, -121, -124, -123, -122, -128, -126, -128, -128, -128, -128, -128, -128, -128, -128, -128, -128, -121, -128, -128, -128, -128, -126, -128, -128, -128, -124, -123, -122, -128, -126, -128, -128, -128, -128, -123, -122, -128, -126, -128, -128, -128, -128, -128, -122, -128, -128, -128, -128, -128, -128, -128, -128, -128};
   private static final WordBreakTable kCharacterForwardTable;
   private static final byte[] kCharacterBackwardData;
   private static final WordBreakTable kCharacterBackwardTable;
   private static final int[] kRawMapping;
   private static final SpecialMapping[] kExceptionChar;
   private static final boolean[] CharacterExceptionFlags;
   private static final int[] kCharacterAsciiValues;
   private static final UnicodeClassMapping kCharacterMap;

   public WordBreakTable forward() {
      return kCharacterForwardTable;
   }

   public WordBreakTable backward() {
      return kCharacterBackwardTable;
   }

   public UnicodeClassMapping map() {
      return kCharacterMap;
   }

   static {
      kCharacterForwardTable = new WordBreakTable(8, kCharacterForwardData);
      kCharacterBackwardData = new byte[]{0, 0, 0, 0, 0, 0, 0, 0, -127, -128, -128, -127, -128, -127, -127, -128};
      kCharacterBackwardTable = new WordBreakTable(8, kCharacterBackwardData);
      kRawMapping = new int[]{1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1};
      kExceptionChar = new SpecialMapping[]{new SpecialMapping('\n', 3), new SpecialMapping('\r', 2), new SpecialMapping('ᄀ', 'ᅟ', 4), new SpecialMapping('ᅠ', 'ᆧ', 5), new SpecialMapping('ᆨ', 'ᇿ', 6), new SpecialMapping('\u2028', '\u2029', 3), new SpecialMapping('\uffff', 7)};
      CharacterExceptionFlags = new boolean[]{false, false, false, false, false, true, false, false, false, false, false, false, false, true, true, true, false, false, false, false, false, false, false, false, false, false, false, false, false};
      kCharacterAsciiValues = new int[]{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1};
      kCharacterMap = new UnicodeClassMapping(kRawMapping, kExceptionChar, CharacterExceptionFlags, kCharacterAsciiValues);
   }
}
