package java.text;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.Serializable;
import java.util.Hashtable;
import java.util.Locale;
import java.util.ResourceBundle;

public final class DecimalFormatSymbols implements Cloneable, Serializable {
   private char zeroDigit;
   private char groupingSeparator;
   private char decimalSeparator;
   private char perMill;
   private char percent;
   private char digit;
   private char patternSeparator;
   private String infinity;
   private String NaN;
   private char minusSign;
   private String currencySymbol;
   private String intlCurrencySymbol;
   private char monetarySeparator;
   private char exponential;
   static final long serialVersionUID = 5772796243397350300L;
   private static final int currentSerialVersion = 1;
   private int serialVersionOnStream = 1;
   private static final Hashtable cachedLocaleData = new Hashtable(3);

   public DecimalFormatSymbols() {
      this.initialize(Locale.getDefault());
   }

   public DecimalFormatSymbols(Locale var1) {
      this.initialize(var1);
   }

   public char getZeroDigit() {
      return this.zeroDigit;
   }

   public void setZeroDigit(char var1) {
      this.zeroDigit = var1;
   }

   public char getGroupingSeparator() {
      return this.groupingSeparator;
   }

   public void setGroupingSeparator(char var1) {
      this.groupingSeparator = var1;
   }

   public char getDecimalSeparator() {
      return this.decimalSeparator;
   }

   public void setDecimalSeparator(char var1) {
      this.decimalSeparator = var1;
   }

   public char getPerMill() {
      return this.perMill;
   }

   public void setPerMill(char var1) {
      this.perMill = var1;
   }

   public char getPercent() {
      return this.percent;
   }

   public void setPercent(char var1) {
      this.percent = var1;
   }

   public char getDigit() {
      return this.digit;
   }

   public void setDigit(char var1) {
      this.digit = var1;
   }

   public char getPatternSeparator() {
      return this.patternSeparator;
   }

   public void setPatternSeparator(char var1) {
      this.patternSeparator = var1;
   }

   public String getInfinity() {
      return this.infinity;
   }

   public void setInfinity(String var1) {
      this.infinity = var1;
   }

   public String getNaN() {
      return this.NaN;
   }

   public void setNaN(String var1) {
      this.NaN = var1;
   }

   public char getMinusSign() {
      return this.minusSign;
   }

   public void setMinusSign(char var1) {
      this.minusSign = var1;
   }

   char getExponentialSymbol() {
      return this.exponential;
   }

   void setExponentialSymbol(char var1) {
      this.exponential = var1;
   }

   String getCurrencySymbol() {
      return this.currencySymbol;
   }

   void setCurrencySymbol(String var1) {
      this.currencySymbol = var1;
   }

   String getInternationalCurrencySymbol() {
      return this.intlCurrencySymbol;
   }

   void setInternationalCurrencySymbol(String var1) {
      this.intlCurrencySymbol = var1;
   }

   char getMonetaryDecimalSeparator() {
      return this.monetarySeparator;
   }

   void setMonetaryDecimalSeparator(char var1) {
      this.monetarySeparator = var1;
   }

   public Object clone() {
      try {
         return (DecimalFormatSymbols)super.clone();
      } catch (CloneNotSupportedException var1) {
         throw new InternalError();
      }
   }

   public boolean equals(Object var1) {
      if (var1 == null) {
         return false;
      } else if (this == var1) {
         return true;
      } else if (this.getClass() != var1.getClass()) {
         return false;
      } else {
         DecimalFormatSymbols var2 = (DecimalFormatSymbols)var1;
         return this.zeroDigit == var2.zeroDigit && this.groupingSeparator == var2.groupingSeparator && this.decimalSeparator == var2.decimalSeparator && this.percent == var2.percent && this.perMill == var2.perMill && this.digit == var2.digit && this.minusSign == var2.minusSign && this.patternSeparator == var2.patternSeparator && this.infinity.equals(var2.infinity) && this.NaN.equals(var2.NaN) && this.currencySymbol.equals(var2.currencySymbol) && this.intlCurrencySymbol.equals(var2.intlCurrencySymbol) && this.monetarySeparator == var2.monetarySeparator;
      }
   }

   public int hashCode() {
      int var1 = this.zeroDigit;
      var1 = var1 * 37 + this.groupingSeparator;
      var1 = var1 * 37 + this.decimalSeparator;
      return var1;
   }

   private void initialize(Locale var1) {
      String[][] var2 = (String[][])cachedLocaleData.get(var1);
      if (var2 == null) {
         var2 = new String[2][];
         ResourceBundle var5 = ResourceBundle.getBundle("java.text.resources.LocaleElements", var1);
         var2[0] = var5.getStringArray("NumberElements");
         var2[1] = var5.getStringArray("CurrencyElements");
         cachedLocaleData.put(var1, var2);
      }

      String[] var3 = var2[0];
      String[] var4 = var2[1];
      this.decimalSeparator = var3[0].charAt(0);
      this.groupingSeparator = var3[1].charAt(0);
      this.patternSeparator = var3[2].charAt(0);
      this.percent = var3[3].charAt(0);
      this.zeroDigit = var3[4].charAt(0);
      this.digit = var3[5].charAt(0);
      this.minusSign = var3[6].charAt(0);
      this.exponential = var3[7].charAt(0);
      this.perMill = var3[8].charAt(0);
      this.infinity = var3[9];
      this.NaN = var3[10];
      this.currencySymbol = var4[0];
      this.intlCurrencySymbol = var4[1];
      this.monetarySeparator = var4[2].charAt(0);
   }

   private void readObject(ObjectInputStream var1) throws IOException, ClassNotFoundException {
      var1.defaultReadObject();
      if (this.serialVersionOnStream < 1) {
         this.monetarySeparator = this.decimalSeparator;
         this.exponential = 'E';
      }

      this.serialVersionOnStream = 1;
   }
}
