package java.text;

class DecompositionIterator {
   public static final char NULLORDER = '\uffff';
   private static final short SHORT_MAX_VALUE = Short.MAX_VALUE;
   private static final char STERMINATOR = '\u0000';
   private static final short[] kOffsetIndex = Utility.RLEStringToShortArray("\u0000Ȁ\u0000aášǡȱʡ̝ΜДҎԇꖥ\u0006Ҏ՞־؞Ҏٽ۩ܶݿߋҎ࠘ࡥࣃूҎҎুੁꖥ\u0018Ҏુୁுుುു\u0dbfҎ฿\u0ebf༭Ҏམ࿌ꖥ\u0016Ҏ၌\u10caᅉᇉ\u1249ዉፉᏉꖥƎҎᑉᓉꖥ\u0004Ҏᕉᗉᙈᛈ");
   private static final short[] kOffsetValues = Utility.RLEStringToShortArray("\u0000ᝈꖥ^翿ಀಃಆꖥ 翿ಉꖥ\u0007翿ಋ翿ಎꖥ\u0004翿ಐ翿翿ಓಕಗಚ翿翿ಜಟಡ翿ಣಧಫ翿\u0000\u0003\u0006\t\f\u000f翿\u0012\u0015\u0018\u001b\u001e!$'*翿-0369<翿翿?BEHK翿翿NQTWZ]翿`cfilorux翿{~\u0081\u0084\u0087\u008a翿翿\u008d\u0090\u0093\u0096\u0099翿\u009c\u009f¢¥¨«®±´·º½ÀÃÆÉÌ翿翿ÏÒÕØÛÞáäçêíðóöùüÿĂąĈ翿翿ċĎđĔėĚĝĠģ翿ಯಲĦĩĬį翿ĲĵĸĻľŁವಸ翿翿ńŇŊōŐœ\u0cbb翿翿ŖřŜşŢť翿翿ŨūŮűŴŷźŽƀƃƆƉƌƏƒƕƘƛ翿翿ƞơƤƧƪƭưƳƶƹƼƿǂǅǈǋǎǑǔǗǚǝǠಾꖥ 翿ǣǦꖥ\r翿ǩǬꖥ\u0013翿ೀೄೈೌ\u0ccf\u0cd2ೕ\u0cd8\u0cdbǯǲǵǸǻǾȁȄȇȋȏȓȗțȟȣ翿ȧȫȯȳȷȺ翿翿ȽɀɃɆɉɌɏɓɗɚɝೞೡ\u0ce4ɠɣꖥ\u0004翿ɦɪɮɱɴɷɺɽʀʃʆʉʌʏʒʕʘʛʞʡʤʧʪʭʰʳʶʹʼʿꖥh翿೧೩೫೭೯ೱೳ\u0cf5\u0cf7ꖥ\u001f翿\u0cf9\u0cfc\u0cffംഅഈ翿翿ഋ\u0d0dഏ\u0d11ഓꖥ\u001b翿˂ꖥ3翿˅ꖥ/翿ˈꖥ\u0005翿കꖥ\u0005翿ഘഛˍː˒˕˘翿˛翿˞ˡˤꖥ\u0019翿˨˫ˮ˱˴˷˺ꖥ\u0019翿˾́̄̇̊ꖥ\u0004翿̍̐ꖥ+翿̓翿̖翿翿翿̙ꖥ\u0004翿̜翿̟ꖥ\n翿̢ꖥ\u001f翿̥ꖥ\u0017翿̨翿̫翿翿翿̮ꖥ\u0004翿̱翿̴ꖥ\u0017翿̷̺ꖥA翿̽̀ꖥ\r翿͉̓͆͌͏͓͖͙͑͛ͣͦͩͬͯ͝͠ͱͳͶ\u0379ͼͿ\u0382΅·ΉΌ翿翿ΏΒΕΘΛΞΡΤ翿翿ΧΪꖥ\u0080翿ടꖥx翿έꖥ\u0007翿ΰ翿翿γꖥ#翿ζιμοςυψϋꖥ0翿ώꖥ\u001a翿ϑϔꖥ\u000f翿ϗϚ翿ϝꖥY翿ϠϣϦϩ翿ϬꖥH翿ϯ翿翿ϲϵꖥ\u000f翿ϸϻ翿Ͼꖥ 翿Ёꖥ5翿ЄЇЊꖥH翿Ѝꖥ@翿Аꖥ\u0006翿ГЖ翿ЙМꖥJ翿РУЦꖥ3翿ЩꖥL翿Ьꖥ(翿ഢഥꖥC翿Яꖥ\t翿вꖥ\u0004翿еꖥ\u0004翿иꖥ\u0004翿лꖥ\f翿оꖥ\t翿с翿фчъюёꖥ\u0006翿ѕꖥ\u0011翿јꖥ\t翿ћꖥ\u0004翿ўꖥ\u0004翿ѡꖥ\u0004翿Ѥꖥ\f翿ѧꖥF翿ന翿翿ഫ翿翿翿മ翿റ翿翿ഴꖥ\u0005翿ഷഺഽീൃെ\u0d49ൌ൏\u0d52ൕ൘൛൞ൡ\u0d64൨൬൰൴൸ൻൾඁ\u0d84ඇඋඎඑඔ\u0d97කඝඡඥඨණථනපභ翿ය翿ල翿වසෆ\u0dc9\u0dccාි\u0dd5ෘෛෞ翿\u0de1翿\u0de4翿෧෪෭翿翿\u0df0ෳ\u0df6ꖥ\t翿\u0df9翿\u0dfc翿\u0dff翿ข翿ฅจฌ翿翿ฏฒถ翿翿น翿ผฟยลศหฮัิืฺ\u0e3eโๅ่๋๏๒๕๘๛\u0e5f\u0e63\u0e67\u0e6a\u0e6d\u0e70\u0e74\u0e77\u0e7b\u0e7eກຄງ\u0e8bຎຑດທບ翿ຝຠຣ\u0ea6ꖥ\u0006翿ຩຬ翿ຯາ翿翿ີຸົ\u0ebeແໄ\u0ec7翿翿໊翿ໍꖥ\u0007翿໐໓໗\u0edaໝ\u0ee0\u0ee3\u0ee6\u0ee9\u0eec\u0ef0\u0ef3\u0ef6\u0efa\u0efd༁༅༉།༑༕༘༛༞༡༤༧༪༮༱༴༷༺༽ཀགྷཆཉཌཏ翿དྷཕཙཛྷ翿ཟརཥཨཫ\u0f6eཱུꖥ\u0007翿ѪѭѰѳѶѹѼѿ҂҆ҊҍҐғҖҙҜҟҢҥҨҬҰҴҸһҾӁӄӈӌӏӒӕӘӛӞӡӤӧӪӭӰӳӶӹӼԀԄԇԊԍԐԓԖԙԜԠԤԧԪԭ\u0530ԳԶԹԼԿՂՅՈՋՎՑՔ\u0557՚՞բզժծղնպսրփֆ։\u058c֏ְִָּ֖֣֦֚֒֝֠֩֬׀ׇׄ\u05ca\u05cdאדזילןעץר\u05eb\u05eeײ\u05f6\u05fa\u05fe\u0601\u0604؇؊؍ؙؐؓؖ\u061c؟آإبثخرشطغؽـكنىٌُْٕ翿ཷꖥ\u0004翿ٛٞ١٤٧٫ٯٳٷٻٿڃڇڋڏړڗڛڟڣڧګگڳڷںڽۀۃۆۉۍۑەۙ\u06ddۡۥ۩ۭ۱۴۷ۺ۽܀܃܆܉܍ܑܕܙܝܡܥܩܭܱܹܵܽ݁݅݉ݍݑݕݙݜݟݢݥݩݭݱݵݹݽށޅމލސޓޖޙޜޟޢꖥ\u0006翿ޥިޫޯ\u07b3\u07b7\u07bb\u07bf߃߆߉ߍߑߕߙߝߡߤߧ߫߯߳翿翿߷ߺ߽ࠁࠅࠉ翿翿ࠍࠐࠓࠗࠛࠟࠣࠧࠫ\u082e࠱࠵࠹࠽ࡁࡅࡉࡌࡏࡓࡗ࡛\u085fࡣࡧࡪ\u086dࡱࡵࡹࡽࢁࢅ࢈ࢋ\u088f\u0893\u0897翿翿࢛࢞ࢡࢥࢩࢭ翿翿ࢱࢴࢷࢻࢿࣃࣇ࣋翿࣏翿࣒翿ࣖ翿ࣰࣚࣞ࣡ࣤࣨ࣬ࣴࣸࣼࣿंआऊऎऒखचझठणदऩबयलवसऻाु翿翿ॄैौ॑ॖज़ॠ॥४८ॲॷॼঁআঋঐঔঘঝঢধব\u09b1শ\u09baাৃৈ্\u09d2ৗড়ৠ\u09e4৩৮৳৸৽ਂਆਊਏਔਙਞਣਨਫਮਲਵ翿ਹ਼ੀ\u0a43\u0a46\u0a49ੌེ\u0a4fཽྀྃ\u0a54\u0a58ਜ਼翿\u0a5f\u0a62੦੩੬੯ੲ྇ྋྏ\u0a7eઁ\u0a84ઈ翿翿ઌએઓખઙજ翿ྒྷྗྛનફમલશહ઼િૃ\u0ac6ૉૌ\u0acfྟྣྦྷ翿翿\u0ad8\u0adc\u0adf翿ૣ૦૪૭૰\u0af3\u0af6ྪྭ翿ྰྲྴྶྸྺྼ྾࿀࿂࿄ꖥ\u0006翿࿆ꖥ\u0005翿࿈ꖥ\f翿࿋\u0fcd࿐ꖥ\f翿࿔࿗翿\u0fdb\u0fdeꖥ\u0004翿\u0fe2翿\u0fe5ꖥ1翿\u0fe8翿翿翿\u0fea\u0fec\u0fee\u0ff0\u0ff2\u0ff4\u0ff6\u0ff8\u0ffa\u0ffc\u0ffeကဂငဆဈညဌဎတဒနဖဘယလသꖥ\u0014翿ᶢꖥ\u0004翿ဠꖥW翿ဣဥ翿翿翿ဨ翿ဪိုေဳဵ့္ျွဿ翿၁၃翿၆၈၊၌၎ၐ翿翿ၒၕၙ翿ၜ翿૿翿ၞ翿ଁଃၠၢ翿ၤၦၨ翿ၪၬၮၰၲၴꖥ\u001a翿ၶၺၾႂႆႊႎ႒႖ႚ႞ႢႦႩႫႮႲႵႷႺႾჃ\u10c6\u10c8\u10cb\u10cfბდვთკნრუქშწჱჴჶჹჽჿᄁᄃꖥ\u0004翿ଆꖥ\u0004翿ଉ翿翿ଌꖥ\u0017翿ଏ翿\u0b12ꖥ\u0005翿ᄅᄈ翿ᄌᄏꖥ\u0013翿କ翿翿ଘ翿ଛꖥ\u0018翿ଞꖥ\n翿ଡ翿翿ତଧ翿翿ପଭ翿翿ରଳꖥ\u0006翿ଶହ翿翿଼ି翿翿ୂ\u0b45ꖥ\"翿ୈୋ\u0b4e\u0b51ꖥ0翿\u0b54ୗ\u0b5aଢ଼ꖥ\u0006翿ୠୣ୦୩ꖥ)翿୬୮ꖥ`翿ᄓᄕᄗᄙᄛᄝᄟᄡᄣᄥᄧᄪᄭᄰᄳᄶᄹᄼᄿᅂꖥ6翿ᅅᅇᅉᅋᅍᅏᅑᅓᅕᅗᅙᅛᅝᅟᅡᅣᅥᅧᅩᅫᅭᅯᅱᅳᅵᅷᅹᅻᅽᅿᆁᆃᆅᆇᆉᆋᆍᆏᆑᆓᆕᆗᆙᆛᆝᆟᆡᆣᆥᆧᆩᆫᆭꖥ\u0015翿ᆯꖥ5翿ᆱꖥ\u0015翿୰翿୳翿୶翿\u0b79翿\u0b7c翿\u0b7f翿ஂ翿அ翿ஈ翿\u0b8b翿எ翿\u0b91翿翿ஔ翿\u0b97翿சꖥ\u0006翿\u0b9d\u0ba0翿ண\u0ba6翿ன\u0bac翿யல翿வஸꖥ\u0014翿\u0bbbꖥ\u0006翿ᆳᆶ翿ாꖥ\r翿ு翿\u0bc4翿ே翿ொ翿்翿ௐ翿\u0bd3翿\u0bd6翿\u0bd9翿\u0bdc翿\u0bdf翿\u0be2翿翿\u0be5翿௨翿௫ꖥ\u0006翿௮௱翿௴௷翿௺\u0bfd翿ఀః翿ఆఉꖥ\u0016翿ఌ翿翿ఏఒకఘ翿翿翿ఛꖥ1翿ᆹᆻᆾᇁᇃᇆᇉᇋᇎᇐᇓᇖᇙᇜᇟᇢᇥᇧᇩᇬᇯᇱᇴᇶᇸᇻᇽᇿሁሃህሇሊሌሏሑሔሖሙማሞሢሥሧሩሬሰሳስሷሺሼሾቁቄቇቊ\u124eቑቕቘቛ\u125eቡቤቧቪቭቱትቸቻቾኂኅኈኋ\u128eኑናኖኘኛኞኡኤኦኩክኰኳ\u12b7ኺኼ翿翿翿\u12bf\u12c1ዃዅ\u12c7ዉዋውዏዑዓዕ\u12d7ዙꖥ`翿ዛዟዣዧያዯዳዷዻዿጃጇጋጏጓጘጝጢጧጬጱጶጻፀፅፊፏፔፙ翿翿翿፞።፦፪፮፲፶፺\u137eᎂᎆᎊᎎ᎒᎖\u139a\u139eᎢᎦᎪᎮᎲᎶᎺᎾᏂᏆᏊᏎᏒᏖᏚᏞᏢᏦᏪꖥ\u001c翿ᏮᏰᏲᏴ\u13f6ᏸᏺᏼ\u13fe᐀ᐂᐄᐆᐈᐊᐍᐐᐓᐖᐙᐜᐟᐢᐥᐨᐫᐮᐱꖥ\u0004翿ᐴᐶᐸᐺᐼᐾᑀᑂᑄᑆᑈᑊᑌᑎᑐᑒᑔᑖᑘᑚᑜᑞᑠᑢᑤᑦᑨᑪᑬᑮᑰᑲᑴᑶᑸᑺᑼᑾᒀᒂᒄᒆᒈᒊᒌᒎᒐᒒᒔꖥ\u000f翿ᒖᒙᒜᒟᒢᒥᒨᒫᒮᒱᒵᒹꖥ\u0004翿ᒽᒿᓁᓃᓅᓇᓉᓋᓍᓏᓑᓓᓕᓗᓙᓛᓝᓟᓡᓣᓥᓧᓩᓫᓭᓯᓱᓳᓵᓷᓹᓻᓽᓿᔁᔃᔅᔇᔉᔋᔍᔏᔑᔓᔕᔗᔙ翿ᔛᔡᔦᔬᔰᔶᔺᔾᕅᕊᕎᕒᕖᕛᕠᕥᕪᕯᕴᕹᖀᖃᖊᖑᖗᖜᖣᖪᖯᖳᖷᖼᗁᗇᗍᗑᗕᗚᗞᗢᗥᗨᗬᗰᗷᗼᘂᘉᘎᘒᘖᘝᘢᘩᘭᘳᘷᘼᙀᙅᙋᙐᙖᙛᙞᙤᙨᙬᙱᙵᙹᙽᚃᚈᚋᚒᚖ᚜ᚡᚦᚪᚮᚳᚶᚻᛁᛄᛋᛏᛒᛕᛘᛛᛞᛡᛤᛧᛪ᛭ᛱᛵ\u16f9\u16fdᜁᜅᜉᜍᜑ᜕\u1719\u171dᜡᜥᜩᜭᜰᜳ\u1737\u173aꖥ\u0004翿\u173dᝀᝃᝆᝉᝎᝑ\u1754\u1757\u175a\u175dᝠᝣᝦᝪᝯᝲ\u1775\u1778\u177b\u177eខងឈឌថបភរឝហឣឦឩឬឯឲាឺួេៅ៉៌័។៙ៜ០៤៨\u17ec៲៹\u17fc\u17ff᠂᠅᠈᠋\u180e᠑᠔᠗\u181a\u181dᠠᠣᠦᠩᠬᠯᠴᠷᠺᠽᡂᡆᡉᡌᡏᡒᡕᡘᡛᡞᡡᡤᡨᡫᡮᡲᡶ\u1879\u187eᢂᢅᢈᢋ翿翿ᢎᢑᢔᢗᢚᢝᢠᢣᢦᢩ\u18adᢱᢵᢹᢽᣁᣅᣉᣍᣑᣕᣙᣝᣡᣥᣩᣭᣱᣵ\u18f9\u18fd翿ᤁᤄᤇᤊᤎᤒᤕꖥ\f翿ᤘᤛᤞᤡᤤꖥ\u0007翿ᤧᤪ\u192c\u192eᤰᤲᤴᤶᤸ᤺\u193cఞడతనబయలవస\u0c3bాుౄ翿ేొ్\u0c50\u0c53翿ౖ翿ౙ\u0c5c翿\u0c5fౢ翿\u0c65౨౫౮\u0c71\u0c74౷౺౽\u193e\u1941\u1943᥅᥇᥉᥋᥍᥏ᥑᥓᥕᥗᥙᥛᥝᥟᥡᥣᥥᥧᥩᥫᥭ\u196fᥱᥳ\u1975\u1977\u1979\u197b\u197d\u197fᦁᦃᦅᦇᦉᦋᦍᦏᦑᦓᦕᦗᦙᦛᦝᦟᦡᦣᦥᦧᦩᦫ\u19ad\u19afᦱᦳᦵᦷᦹᦻᦽᦿᧁᧃᧅᧇᧉ\u19cb\u19cd\u19cf᧑᧓᧕᧗᧙\u19db\u19dd᧟᧡᧣᧥᧧᧩᧫᧭᧯᧱᧳᧵᧷᧹᧻᧽᧿ᨁᨃꖥ!翿ᨅᨇᨉᨋᨍᨏᨑᨓᨕᨗᨙᨛ\u1a1d᨟ᨡᨣᨥᨧᨩᨫᨭꖥ\u0014翿ᨯᨱᨳᨵꖥ0翿ᨷᨺᨼᨾᩁᩄᩆᩈᩊᩌᩎᩐᩒᩔᩖᩘᩚᩜᩞ᩠ᩢꖥ\u0004翿ᩤᩧᩪᩭᩰᩳ᩶᩹᩻\u1a7d翿᩿᪁᪃᪅᪇᪉\u1a8b\u1a8d\u1a8f᪑᪓᪕᪗᪙\u1a9b\u1a9d\u1a9f᪡᪣翿᪥ᪧ᪩᪫ꖥ\u0004翿᪭᪰᪳翿᪶翿᪹ᪿ᪼᫂᫅᫈᫋ᫎ\u1ad1\u1ad4\u1ad7\u1ad9\u1adb\u1add\u1adf\u1ae1\u1ae3\u1ae5\u1ae7\u1ae9\u1aeb\u1aed\u1aef\u1af1\u1af3\u1af5\u1af7\u1af9\u1afb\u1afd\u1affᬁᬃᬅᬇᬉᬋᬍᬏᬑᬓᬕᬗᬙᬛᬝᬟᬡᬣᬥᬧᬩᬫᬭᬯᬱᬳᬵᬷᬹᬻᬽᬿᭁᭃᭅᭇᭉᭋ\u1b4d\u1b4f᭑᭓᭕᭗᭙᭛᭝᭟᭡᭣᭥᭧᭩᭫᭭᭯᭱᭳᭵᭷᭹᭻᭽\u1b7fᮁᮃᮅᮇᮉᮋᮍᮏᮑᮓᮕᮗᮙᮛᮝᮟᮡᮣᮥᮧᮩ᮫ᮭᮯ᮱᮳᮵᮷᮹ᮻᮽᮿꖥ\u000b翿ᯁᯃᯅᯇᯉᯋᯍᯏᯑᯓᯕᯗᯙᯛᯝᯟᯡᯣᯥᯧᯩᯫᯭᯯᯱ᯳\u1bf5\u1bf7\u1bf9\u1bfb᯽᯿ᰁᰃᰅᰇᰉᰋᰍᰏᰑᰓᰕᰗᰙᰛᰝᰟᰡᰣᰥᰧᰩᰫᰭᰯᰱᰳᰵ᰷\u1c39᰻᰾᱁᱄᱆᱈\u1c4a\u1c4cᱎ᱐᱒᱔᱖᱘ᱚᱜᱞᱠᱢᱤᱦᱨᱪᱬᱮᱰᱲᱴᱶᱸᱺᱼ᱾翿翿ᲀᲂᲄᲆᲈ\u1c8a\u1c8c\u1c8eᲐᲒᲔᲖᲘᲚᲜᲞᲠᲢᲤᲦᲨᲪᲬᲮᲰᲲᲴᲶᲸᲺ\u1cbcᲾ᳀᳂᳄᳆\u1cc8\u1cca\u1ccc\u1cce᳔᳢᳤᳦᳨᳖᳘᳜᳞᳐᳒᳚᳠ᳪᳬᳮᳰᳲ᳴ᳶ᳸ᳺ\u1cfdᴀᴂᴄᴇᴊᴌᴏᴒᴔᴗᴙᴜᴟᴢᴥᴨᴫᴮᴰᴲᴵᴸᴺᴽᴿᵁᵄᵆᵈᵊᵌ翿翿翿ᵎᵐᵓᵕᵘᵚ翿翿ᵝᵟᵢᵤᵧᵫ翿翿ᵮᵰᵲᵵᵹᵼ翿翿ᵾᶀᶃ翿翿翿ᶅᶇᶉᶋᶎᶐᶒ翿ᶔᶖᶘᶚᶜᶞᶠꖥ\u0011翿");
   private static final short[] kCanonicalIndex = Utility.RLEStringToShortArray("\u0000Ȁꖥ\u0006\u0000\u0080\u0000\u0000ý\u0000ŬƱȢꖥ\u0004\u0000ʡ̠ΞНҜӳՁ֘צ\u0000صڄ۬ݬꖥ!\u0000ަꖥ\u001e\u0000ࠈ\u086fꖥƔ\u0000࣑ꖥ\u0005\u0000ऱ\u0000\u0000\u0000");
   private static final byte[] kCanonicalValues = Utility.RLEStringToByteArray("\u0000\u09b1ꖀ肥ᕦ梥ќ桘ꔅ届䪥ќ䩊ꔋ岥ցꔄ岥ࡦ岥᪀橪ꔞ肥Ѧꕹ聜ꔄ晜晦晞岥٦肥՜晦屦晞晦誋貍躏邑銓肔閖肗肘馀暥䮀鮜鶞龠ꆢꔝ肣ꕖ肥ݦ肀ꔄ晜暀聦暀屦晜ꔒ肥ꖤꔹ肇ꔄ肦Ꞩꦪꮬ궥Ҁ覀肀꺯晦ꔍ肰놥ᲀ능㪀螥Ҁ뎴떶ꔈ肉ꔔ肷뢥ᲀ릥㦀螥Ҁ못ꔄ肼부肾뾉ꔢ胀솥\u0e80쏂ꔹ肇ꔄ胄없쟈胉쪥Ҁ覥㊀쮥㪀螀背胍컏ꔉ肉ꔈ聦ꕀ胐ꔌ肉ꔾ胑틓ꔅ胔헖胗\ud8d9覥ހ\udadbꔿ胜ꔆ胝ꔅ胞覥䆀\udfe0\ue1a5ঀ覥㊀\ue280胣\ue4e5\ue6e7\ue8e9ꔌ胪\uebec\uedee\ueff0¥ㆀ\uf180胲\uf3f4\uf5f6\uf780\uf8f9ꔋ胺ﯼ﷾ﾥ㊀屜ꔛ聦聦聘ꔄ聜岥ㆀĂ̄Ԇ܈ऊଌഎ耏ၦ暉肥٦ꔄ肥چ肆肥ᖆ肀肥ކ肆ꕐ聦暁膥Ѧ膁腦暥Ҁ膥⪀婤桞恠ꕐ肈袥斀骥憀ꔄ暥岀");
   private static String contents = "À\u0000Á\u0000Â\u0000Ã\u0000Ä\u0000Å\u0000Ç\u0000È\u0000É\u0000Ê\u0000Ë\u0000Ì\u0000Í\u0000Î\u0000Ï\u0000Ñ\u0000Ò\u0000Ó\u0000Ô\u0000Õ\u0000Ö\u0000Ù\u0000Ú\u0000Û\u0000Ü\u0000Ý\u0000à\u0000á\u0000â\u0000ã\u0000ä\u0000å\u0000ç\u0000è\u0000é\u0000ê\u0000ë\u0000ì\u0000í\u0000î\u0000ï\u0000ñ\u0000ò\u0000ó\u0000ô\u0000õ\u0000ö\u0000ù\u0000ú\u0000û\u0000ü\u0000ý\u0000ÿ\u0000Ā\u0000ā\u0000Ă\u0000ă\u0000Ą\u0000ą\u0000Ć\u0000ć\u0000Ĉ\u0000ĉ\u0000Ċ\u0000ċ\u0000Č\u0000č\u0000Ď\u0000ď\u0000Ē\u0000ē\u0000Ĕ\u0000ĕ\u0000Ė\u0000ė\u0000Ę\u0000ę\u0000Ě\u0000ě\u0000Ĝ\u0000ĝ\u0000Ğ\u0000ğ\u0000Ġ\u0000ġ\u0000Ģ\u0000ģ\u0000Ĥ\u0000ĥ\u0000Ĩ\u0000ĩ\u0000Ī\u0000ī\u0000Ĭ\u0000ĭ\u0000Į\u0000į\u0000İ\u0000Ĵ\u0000ĵ\u0000Ķ\u0000ķ\u0000Ĺ\u0000ĺ\u0000Ļ\u0000ļ\u0000Ľ\u0000ľ\u0000Ń\u0000ń\u0000Ņ\u0000ņ\u0000Ň\u0000ň\u0000Ō\u0000ō\u0000Ŏ\u0000ŏ\u0000Ő\u0000ő\u0000Ŕ\u0000ŕ\u0000Ŗ\u0000ŗ\u0000Ř\u0000ř\u0000Ś\u0000ś\u0000Ŝ\u0000ŝ\u0000Ş\u0000ş\u0000Š\u0000š\u0000Ţ\u0000ţ\u0000Ť\u0000ť\u0000Ũ\u0000ũ\u0000Ū\u0000ū\u0000Ŭ\u0000ŭ\u0000Ů\u0000ů\u0000Ű\u0000ű\u0000Ų\u0000ų\u0000Ŵ\u0000ŵ\u0000Ŷ\u0000ŷ\u0000Ÿ\u0000Ź\u0000ź\u0000Ż\u0000ż\u0000Ž\u0000ž\u0000Ơ\u0000ơ\u0000Ư\u0000ư\u0000Ǎ\u0000ǎ\u0000Ǐ\u0000ǐ\u0000Ǒ\u0000ǒ\u0000Ǔ\u0000ǔ\u0000Ǖ\u0000ǖ\u0000Ǘ\u0000ǘ\u0000Ǚ\u0000ǚ\u0000Ǜ\u0000ǜ\u0000Ǟ\u0000ǟ\u0000Ǡ\u0000ǡ\u0000Ǣ\u0000ǣ\u0000Ǧ\u0000ǧ\u0000Ǩ\u0000ǩ\u0000Ǫ\u0000ǫ\u0000Ǭ\u0000ǭ\u0000Ǯ\u0000ǯ\u0000ǰ\u0000Ǵ\u0000ǵ\u0000Ǻ\u0000ǻ\u0000Ǽ\u0000ǽ\u0000Ǿ\u0000ǿ\u0000Ȁ\u0000ȁ\u0000Ȃ\u0000ȃ\u0000Ȅ\u0000ȅ\u0000Ȇ\u0000ȇ\u0000Ȉ\u0000ȉ\u0000Ȋ\u0000ȋ\u0000Ȍ\u0000ȍ\u0000Ȏ\u0000ȏ\u0000Ȑ\u0000ȑ\u0000Ȓ\u0000ȓ\u0000Ȕ\u0000ȕ\u0000Ȗ\u0000ȗ\u0000̆̇\u0000̈̍\u0000ʹ\u0000¨̍\u0000Α̍\u0000·\u0000Ε̍\u0000Η̍\u0000Ι̍\u0000Ο̍\u0000Υ̍\u0000Ω̍\u0000ϊ̍\u0000Ϊ\u0000Ϋ\u0000α̍\u0000ε̍\u0000η̍\u0000ι̍\u0000ϋ̍\u0000ϊ\u0000ϋ\u0000ο̍\u0000υ̍\u0000ω̍\u0000ϒ̍\u0000ϔ\u0000Ё\u0000Ѓ\u0000Ї\u0000Ќ\u0000Ў\u0000Й\u0000й\u0000ё\u0000ѓ\u0000ї\u0000ќ\u0000ў\u0000Ѷ\u0000ѷ\u0000Ӂ\u0000ӂ\u0000Ӑ\u0000ӑ\u0000Ӓ\u0000ӓ\u0000Æ\u0000æ\u0000Ӗ\u0000ӗ\u0000Ə\u0000ə\u0000Ə̈\u0000ə̈\u0000Ӝ\u0000ӝ\u0000Ӟ\u0000ӟ\u0000Ʒ\u0000ʒ\u0000Ӣ\u0000ӣ\u0000Ӥ\u0000ӥ\u0000Ӧ\u0000ӧ\u0000Ɵ\u0000ɵ\u0000Ɵ̈\u0000ɵ̈\u0000Ӯ\u0000ӯ\u0000Ӱ\u0000ӱ\u0000Ӳ\u0000ӳ\u0000Ӵ\u0000ӵ\u0000Ӹ\u0000ӹ\u0000ऩ\u0000ऱ\u0000ऴ\u0000क़\u0000ख़\u0000ग़\u0000ज़\u0000ड़\u0000ढ़\u0000फ़\u0000य़\u0000ব়\u0000ো\u0000ৌ\u0000ড়\u0000ঢ়\u0000য়\u0000ਖ਼\u0000ਗ਼\u0000ਜ਼\u0000ਡ਼\u0000ਫ਼\u0000ୈ\u0000ୋ\u0000ୌ\u0000ଡ଼\u0000ଢ଼\u0000ଯ଼\u0000ஔ\u0000ொ\u0000ோ\u0000ௌ\u0000ై\u0000ೀ\u0000ೇ\u0000ೈ\u0000ೊ\u0000ೋ\u0000ൊ\u0000ോ\u0000ൌ\u0000ํา\u0000ໍາ\u0000གྷ\u0000ཌྷ\u0000དྷ\u0000བྷ\u0000ཛྷ\u0000ཀྵ\u0000ཱི\u0000ཱུ\u0000ྲྀ\u0000ྲཱྀ\u0000ླྀ\u0000ླཱྀ\u0000ཱྀ\u0000ྒྷ\u0000ྜྷ\u0000ྡྷ\u0000ྦྷ\u0000ྫྷ\u0000ྐྵ\u0000Ḁ\u0000ḁ\u0000Ḃ\u0000ḃ\u0000Ḅ\u0000ḅ\u0000Ḇ\u0000ḇ\u0000Ḉ\u0000ḉ\u0000Ḋ\u0000ḋ\u0000Ḍ\u0000ḍ\u0000Ḏ\u0000ḏ\u0000Ḑ\u0000ḑ\u0000Ḓ\u0000ḓ\u0000Ḕ\u0000ḕ\u0000Ḗ\u0000ḗ\u0000Ḙ\u0000ḙ\u0000Ḛ\u0000ḛ\u0000Ḝ\u0000ḝ\u0000Ḟ\u0000ḟ\u0000Ḡ\u0000ḡ\u0000Ḣ\u0000ḣ\u0000Ḥ\u0000ḥ\u0000Ḧ\u0000ḧ\u0000Ḩ\u0000ḩ\u0000Ḫ\u0000ḫ\u0000Ḭ\u0000ḭ\u0000Ḯ\u0000ḯ\u0000Ḱ\u0000ḱ\u0000Ḳ\u0000ḳ\u0000Ḵ\u0000ḵ\u0000Ḷ\u0000ḷ\u0000Ḹ\u0000ḹ\u0000Ḻ\u0000ḻ\u0000Ḽ\u0000ḽ\u0000Ḿ\u0000ḿ\u0000Ṁ\u0000ṁ\u0000Ṃ\u0000ṃ\u0000Ṅ\u0000ṅ\u0000Ṇ\u0000ṇ\u0000Ṉ\u0000ṉ\u0000Ṋ\u0000ṋ\u0000Ṍ\u0000ṍ\u0000Ṏ\u0000ṏ\u0000Ṑ\u0000ṑ\u0000Ṓ\u0000ṓ\u0000Ṕ\u0000ṕ\u0000Ṗ\u0000ṗ\u0000Ṙ\u0000ṙ\u0000Ṛ\u0000ṛ\u0000Ṝ\u0000ṝ\u0000Ṟ\u0000ṟ\u0000Ṡ\u0000ṡ\u0000Ṣ\u0000ṣ\u0000Ṥ\u0000ṥ\u0000Ṧ\u0000ṧ\u0000Ṩ\u0000ṩ\u0000Ṫ\u0000ṫ\u0000Ṭ\u0000ṭ\u0000Ṯ\u0000ṯ\u0000Ṱ\u0000ṱ\u0000Ṳ\u0000ṳ\u0000Ṵ\u0000ṵ\u0000Ṷ\u0000ṷ\u0000Ṹ\u0000ṹ\u0000Ṻ\u0000ṻ\u0000Ṽ\u0000ṽ\u0000Ṿ\u0000ṿ\u0000Ẁ\u0000ẁ\u0000Ẃ\u0000ẃ\u0000Ẅ\u0000ẅ\u0000Ẇ\u0000ẇ\u0000Ẉ\u0000ẉ\u0000Ẋ\u0000ẋ\u0000Ẍ\u0000ẍ\u0000Ẏ\u0000ẏ\u0000Ẑ\u0000ẑ\u0000Ẓ\u0000ẓ\u0000Ẕ\u0000ẕ\u0000ẖ\u0000ẗ\u0000ẘ\u0000ẙ\u0000ẛ\u0000Ạ\u0000ạ\u0000Ả\u0000ả\u0000Ấ\u0000ấ\u0000Ầ\u0000ầ\u0000Ẩ\u0000ẩ\u0000Ẫ\u0000ẫ\u0000Ậ\u0000ậ\u0000Ắ\u0000ắ\u0000Ằ\u0000ằ\u0000Ẳ\u0000ẳ\u0000Ẵ\u0000ẵ\u0000Ặ\u0000ặ\u0000Ẹ\u0000ẹ\u0000Ẻ\u0000ẻ\u0000Ẽ\u0000ẽ\u0000Ế\u0000ế\u0000Ề\u0000ề\u0000Ể\u0000ể\u0000Ễ\u0000ễ\u0000Ệ\u0000ệ\u0000Ỉ\u0000ỉ\u0000Ị\u0000ị\u0000Ọ\u0000ọ\u0000Ỏ\u0000ỏ\u0000Ố\u0000ố\u0000Ồ\u0000ồ\u0000Ổ\u0000ổ\u0000Ỗ\u0000ỗ\u0000Ộ\u0000ộ\u0000Ớ\u0000ớ\u0000Ờ\u0000ờ\u0000Ở\u0000ở\u0000Ỡ\u0000ỡ\u0000Ợ\u0000ợ\u0000Ụ\u0000ụ\u0000Ủ\u0000ủ\u0000Ứ\u0000ứ\u0000Ừ\u0000ừ\u0000Ử\u0000ử\u0000Ữ\u0000ữ\u0000Ự\u0000ự\u0000Ỳ\u0000ỳ\u0000Ỵ\u0000ỵ\u0000Ỷ\u0000ỷ\u0000Ỹ\u0000ỹ\u0000ἀ\u0000ἁ\u0000ἂ\u0000ἃ\u0000ἄ\u0000ἅ\u0000ἆ\u0000ἇ\u0000Ἀ\u0000Ἁ\u0000Ἂ\u0000Ἃ\u0000Ἄ\u0000Ἅ\u0000Ἆ\u0000Ἇ\u0000ἐ\u0000ἑ\u0000ἒ\u0000ἓ\u0000ἔ\u0000ἕ\u0000Ἐ\u0000Ἑ\u0000Ἒ\u0000Ἓ\u0000Ἔ\u0000Ἕ\u0000ἠ\u0000ἡ\u0000ἢ\u0000ἣ\u0000ἤ\u0000ἥ\u0000ἦ\u0000ἧ\u0000Ἠ\u0000Ἡ\u0000Ἢ\u0000Ἣ\u0000Ἤ\u0000Ἥ\u0000Ἦ\u0000Ἧ\u0000ἰ\u0000ἱ\u0000ἲ\u0000ἳ\u0000ἴ\u0000ἵ\u0000ἶ\u0000ἷ\u0000Ἰ\u0000Ἱ\u0000Ἲ\u0000Ἳ\u0000Ἴ\u0000Ἵ\u0000Ἶ\u0000Ἷ\u0000ὀ\u0000ὁ\u0000ὂ\u0000ὃ\u0000ὄ\u0000ὅ\u0000Ὀ\u0000Ὁ\u0000Ὂ\u0000Ὃ\u0000Ὄ\u0000Ὅ\u0000ὐ\u0000ὑ\u0000ὒ\u0000ὓ\u0000ὔ\u0000ὕ\u0000ὖ\u0000ὗ\u0000Ὑ\u0000Ὓ\u0000Ὕ\u0000Ὗ\u0000ὠ\u0000ὡ\u0000ὢ\u0000ὣ\u0000ὤ\u0000ὥ\u0000ὦ\u0000ὧ\u0000Ὠ\u0000Ὡ\u0000Ὢ\u0000Ὣ\u0000Ὤ\u0000Ὥ\u0000Ὦ\u0000Ὧ\u0000ὰ\u0000ά\u0000ὲ\u0000έ\u0000ὴ\u0000ή\u0000ὶ\u0000ί\u0000ὸ\u0000ό\u0000ὺ\u0000ύ\u0000ὼ\u0000ώ\u0000ᾀ\u0000ᾁ\u0000ᾲ̓\u0000ᾲ̔\u0000ᾴ̓\u0000ᾴ̔\u0000ᾷ̓\u0000ᾷ̔\u0000ᾈ\u0000ᾉ\u0000Ὰ̓ͅ\u0000Ὰ̔ͅ\u0000Ά̓ͅ\u0000Ά̔ͅ\u0000ᾼ͂̓\u0000ᾼ͂̔\u0000ᾐ\u0000ᾑ\u0000ῂ̓\u0000ῂ̔\u0000ῄ̓\u0000ῄ̔\u0000ῇ̓\u0000ῇ̔\u0000ᾘ\u0000ᾙ\u0000Ὴ̓ͅ\u0000Ὴ̔ͅ\u0000Ή̓ͅ\u0000Ή̔ͅ\u0000ῌ͂̓\u0000ῌ͂̔\u0000ᾠ\u0000ᾡ\u0000ῲ̓\u0000ῲ̔\u0000ῴ̓\u0000ῴ̔\u0000ῷ̓\u0000ῷ̔\u0000ᾨ\u0000ᾩ\u0000Ὼ̓ͅ\u0000Ὼ̔ͅ\u0000Ώ̓ͅ\u0000Ώ̔ͅ\u0000ῼ͂̓\u0000ῼ͂̔\u0000ᾰ\u0000ᾱ\u0000ᾲ\u0000ᾳ\u0000ᾴ\u0000ᾶ\u0000ᾷ\u0000Ᾰ\u0000Ᾱ\u0000Ὰ\u0000Ά\u0000ᾼ\u0000Ι\u0000῁\u0000ῂ\u0000ῃ\u0000ῄ\u0000ῆ\u0000ῇ\u0000Ὲ\u0000Έ\u0000Ὴ\u0000Ή\u0000ῌ\u0000῍\u0000῎\u0000῏\u0000ῐ\u0000ῑ\u0000ῒ\u0000ΐ\u0000ῖ\u0000ῗ\u0000Ῐ\u0000Ῑ\u0000Ὶ\u0000Ί\u0000῝\u0000῞\u0000῟\u0000ῠ\u0000ῡ\u0000ῢ\u0000ΰ\u0000ῤ\u0000ῥ\u0000ῦ\u0000ῧ\u0000Ῠ\u0000Ῡ\u0000Ὺ\u0000Ύ\u0000Ῥ\u0000῭\u0000΅\u0000ῲ\u0000ῳ\u0000όͅ\u0000ῶ\u0000ῷ\u0000Ὸ\u0000Ό\u0000Ὼ\u0000Ώ\u0000ῼ\u0000´\u0000 \u0000 \u0000Ω\u0000K\u0000Å\u0000∄\u0000∉\u0000∌\u0000∤\u0000∦\u0000≄\u0000≇\u0000≉\u0000≢\u0000≭\u0000≰\u0000≱\u0000≴\u0000≵\u0000≸\u0000≹\u0000⊀\u0000⊁\u0000⊄\u0000⊅\u0000⊈\u0000⊉\u0000⊬\u0000⊭\u0000⊮\u0000⊯\u0000⋠\u0000⋡\u0000⋢\u0000⋣\u0000⋪\u0000⋫\u0000⋬\u0000⋭\u0000〈\u0000〉\u0000が\u0000ぎ\u0000ぐ\u0000げ\u0000ご\u0000ざ\u0000じ\u0000ず\u0000ぜ\u0000ぞ\u0000だ\u0000ぢ\u0000づ\u0000で\u0000ど\u0000ば\u0000ぱ\u0000び\u0000ぴ\u0000ぶ\u0000ぷ\u0000べ\u0000ぺ\u0000ぼ\u0000ぽ\u0000ゔ\u0000ゞ\u0000ガ\u0000ギ\u0000グ\u0000ゲ\u0000ゴ\u0000ザ\u0000ジ\u0000ズ\u0000ゼ\u0000ゾ\u0000ダ\u0000ヂ\u0000ヅ\u0000デ\u0000ド\u0000バ\u0000パ\u0000ビ\u0000ピ\u0000ブ\u0000プ\u0000ベ\u0000ペ\u0000ボ\u0000ポ\u0000ヴ\u0000ヷ\u0000ヸ\u0000ヹ\u0000ヺ\u0000ヾ\u0000שׁ\u0000שׂ\u0000שּׁ\u0000שּׂ\u0000אַ\u0000אָ\u0000אּ\u0000בּ\u0000גּ\u0000דּ\u0000הּ\u0000וּ\u0000זּ\u0000טּ\u0000יּ\u0000ךּ\u0000כּ\u0000לּ\u0000מּ\u0000נּ\u0000סּ\u0000ףּ\u0000פּ\u0000צּ\u0000קּ\u0000רּ\u0000שּ\u0000תּ\u0000וֹ\u0000בֿ\u0000כֿ\u0000פֿ\u0000 ̂\u0000 ̲\u0000 ̀\u0000 \u0000 ̈\u0000a\u0000 ̄\u00002\u00003\u0000 ́\u0000μ\u0000 ̧\u00001\u0000o\u00001⁄4\u00001⁄2\u00003⁄4\u0000IJ\u0000ij\u0000L·\u0000l·\u0000ʼn\u0000s\u0000DŽ\u0000Dž\u0000dž\u0000LJ\u0000Lj\u0000lj\u0000NJ\u0000Nj\u0000nj\u0000DZ\u0000Dz\u0000dz\u0000h\u0000ɦ\u0000j\u0000r\u0000ɹ\u0000ɻ\u0000ʁ\u0000w\u0000y\u0000 ̆\u0000 ̇\u0000 ̊\u0000 ̨\u0000 ̃\u0000 ̋\u0000ɣ\u0000l\u0000s\u0000x\u0000ʕ\u0000 ͅ\u0000 ̍\u0000 ̈̍\u0000եւ\u0000ຫນ\u0000ຫມ\u0000ᄀᄀ\u0000ᄃᄃ\u0000ᄇᄇ\u0000ᄉᄉ\u0000ᄌᄌ\u0000ᄂᄀ\u0000ᄂᄂ\u0000ᄂᄃ\u0000ᄂᄇ\u0000ᄃᄀ\u0000ᄅᄂ\u0000ᄅᄅ\u0000ᄅᄒ\u0000ᄅᄋ\u0000ᄆᄇ\u0000ᄆᄋ\u0000ᄇᄀ\u0000ᄇᄂ\u0000ᄇᄃ\u0000ᄇᄉ\u0000ᄇᄉᄀ\u0000ᄇᄉᄃ\u0000ᄇᄉᄇ\u0000ᄇᄉᄉ\u0000ᄇᄉᄌ\u0000ᄇᄌ\u0000ᄇᄎ\u0000ᄇᄐ\u0000ᄇᄑ\u0000ᄇᄋ\u0000ᄇᄇᄋ\u0000ᄉᄀ\u0000ᄉᄂ\u0000ᄉᄃ\u0000ᄉᄅ\u0000ᄉᄆ\u0000ᄉᄇ\u0000ᄉᄇᄀ\u0000ᄉᄉᄉ\u0000ᄉᄋ\u0000ᄉᄌ\u0000ᄉᄎ\u0000ᄉᄏ\u0000ᄉᄐ\u0000ᄉᄑ\u0000ᄉᄒ\u0000ᄼᄼ\u0000ᄾᄾ\u0000ᄋᄀ\u0000ᄋᄃ\u0000ᄋᄆ\u0000ᄋᄇ\u0000ᄋᄉ\u0000ᄋᅀ\u0000ᄋᄋ\u0000ᄋᄌ\u0000ᄋᄎ\u0000ᄋᄐ\u0000ᄋᄑ\u0000ᄌᄋ\u0000ᅎᅎ\u0000ᅐᅐ\u0000ᄎᄏ\u0000ᄎᄒ\u0000ᄑᄇ\u0000ᄑᄋ\u0000ᄒᄒ\u0000ᅡᅵ\u0000ᅣᅵ\u0000ᅥᅵ\u0000ᅧᅵ\u0000ᅩᅡ\u0000ᅩᅡᅵ\u0000ᅩᅵ\u0000ᅮᅥ\u0000ᅮᅥᅵ\u0000ᅮᅵ\u0000ᅳᅵ\u0000ᅡᅩ\u0000ᅡᅮ\u0000ᅣᅩ\u0000ᅣᅭ\u0000ᅥᅩ\u0000ᅥᅮ\u0000ᅥᅳ\u0000ᅧᅩ\u0000ᅧᅮ\u0000ᅩᅥ\u0000ᅩᅥᅵ\u0000ᅩᅧᅵ\u0000ᅩᅩ\u0000ᅩᅮ\u0000ᅭᅣ\u0000ᅭᅣᅵ\u0000ᅭᅧ\u0000ᅭᅩ\u0000ᅭᅵ\u0000ᅮᅡ\u0000ᅮᅡᅵ\u0000ᅮᅥᅳ\u0000ᅮᅧᅵ\u0000ᅮᅮ\u0000ᅲᅡ\u0000ᅲᅥ\u0000ᅲᅥᅵ\u0000ᅲᅧ\u0000ᅲᅧᅵ\u0000ᅲᅮ\u0000ᅲᅵ\u0000ᅳᅮ\u0000ᅳᅳ\u0000ᅳᅵᅮ\u0000ᅵᅡ\u0000ᅵᅣ\u0000ᅵᅩ\u0000ᅵᅮ\u0000ᅵᅳ\u0000ᅵᆞ\u0000ᆞᅥ\u0000ᆞᅮ\u0000ᆞᅵ\u0000ᆞᆞ\u0000ᆨᆨ\u0000ᆨᆺ\u0000ᆫᆽ\u0000ᆫᇂ\u0000ᆯᆨ\u0000ᆯᆷ\u0000ᆯᆸ\u0000ᆯᆺ\u0000ᆯᇀ\u0000ᆯᇁ\u0000ᆯᇂ\u0000ᆸᆺ\u0000ᆺᆺ\u0000ᆨᆯ\u0000ᆨᆺᆨ\u0000ᆫᆨ\u0000ᆫᆮ\u0000ᆫᆺ\u0000ᆫᇫ\u0000ᆫᇀ\u0000ᆮᆨ\u0000ᆮᆯ\u0000ᆯᆨᆺ\u0000ᆯᆫ\u0000ᆯᆮ\u0000ᆯᆮᇂ\u0000ᆯᆯ\u0000ᆯᆷᆨ\u0000ᆯᆷᆺ\u0000ᆯᆸᆺ\u0000ᆯᆸᇂ\u0000ᆯᆸᆼ\u0000ᆯᆺᆺ\u0000ᆯᇫ\u0000ᆯᆿ\u0000ᆯᇹ\u0000ᆷᆨ\u0000ᆷᆯ\u0000ᆷᆸ\u0000ᆷᆺ\u0000ᆷᆺᆺ\u0000ᆷᇫ\u0000ᆷᆾ\u0000ᆷᇂ\u0000ᆷᆼ\u0000ᆸᆯ\u0000ᆸᇁ\u0000ᆸᇂ\u0000ᆸᆼ\u0000ᆺᆨ\u0000ᆺᆮ\u0000ᆺᆯ\u0000ᆺᆸ\u0000ᆼᆨ\u0000ᆼᆨᆨ\u0000ᆼᆼ\u0000ᆼᆿ\u0000ᇰᆺ\u0000ᇰᇫ\u0000ᇁᆸ\u0000ᇁᆼ\u0000ᇂᆫ\u0000ᇂᆯ\u0000ᇂᆷ\u0000ᇂᆸ\u0000ṡ\u0000 ̓\u0000 ̓\u0000 ͂\u0000 ̈͂\u0000 ̓̀\u0000 ̓́\u0000 ̓͂\u0000 ̔̀\u0000 ̔́\u0000 ̔͂\u0000 ̈̀\u0000 ̈́\u0000 ̀\u0000 ́\u0000 ̔\u0000 \u0000 \u0000 \u0000 \u0000 \u0000 \u0000 \u0000 \u0000 \u0000 \u0000 \u0000‐\u0000 ̳\u0000.\u0000..\u0000...\u0000′′\u0000′′′\u0000‵‵\u0000‵‵‵\u0000!!\u0000 ̅\u00000\u00004\u00005\u00006\u00007\u00008\u00009\u0000+\u0000−\u0000=\u0000(\u0000)\u0000n\u00000\u00001\u00002\u00003\u00004\u00005\u00006\u00007\u00008\u00009\u0000+\u0000−\u0000=\u0000(\u0000)\u0000Rs\u0000C\u0000°C\u0000Ɛ\u0000°F\u0000g\u0000H\u0000H\u0000H\u0000h\u0000ħ\u0000I\u0000I\u0000L\u0000l\u0000N\u0000No\u0000P\u0000P\u0000Q\u0000R\u0000R\u0000R\u0000SM\u0000TEL\u0000TM\u0000Z\u0000Z\u0000B\u0000C\u0000e\u0000E\u0000F\u0000M\u0000o\u0000א\u0000ב\u0000ג\u0000ד\u00001⁄3\u00002⁄3\u00001⁄5\u00002⁄5\u00003⁄5\u00004⁄5\u00001⁄6\u00005⁄6\u00001⁄8\u00003⁄8\u00005⁄8\u00007⁄8\u00001⁄\u0000I\u0000II\u0000III\u0000IV\u0000V\u0000VI\u0000VII\u0000VIII\u0000IX\u0000X\u0000XI\u0000XII\u0000L\u0000C\u0000D\u0000M\u0000i\u0000ii\u0000iii\u0000iv\u0000v\u0000vi\u0000vii\u0000viii\u0000ix\u0000x\u0000xi\u0000xii\u0000l\u0000c\u0000d\u0000m\u0000∫∫\u0000∫∫∫\u0000∮∮\u0000∮∮∮\u00001\u00002\u00003\u00004\u00005\u00006\u00007\u00008\u00009\u00001\u000010\u000012\u000013\u000014\u000015\u000016\u000017\u000018\u000019\u000020\u0000A\u0000B\u0000C\u0000D\u0000E\u0000F\u0000G\u0000H\u0000I\u0000J\u0000K\u0000L\u0000M\u0000N\u0000O\u0000P\u0000Q\u0000R\u0000S\u0000T\u0000U\u0000V\u0000W\u0000X\u0000Y\u0000Z\u0000a\u0000b\u0000c\u0000d\u0000e\u0000f\u0000g\u0000h\u0000i\u0000j\u0000k\u0000l\u0000m\u0000n\u0000o\u0000p\u0000q\u0000r\u0000s\u0000t\u0000u\u0000v\u0000w\u0000x\u0000y\u0000z\u00000\u0000 \u0000〒\u0000 ゙\u0000 ゚\u0000ᄀ\u0000ᄀᄀ\u0000ᆨᆺ\u0000ᄂ\u0000ᆫᆽ\u0000ᆫᇂ\u0000ᄃ\u0000ᄃᄃ\u0000ᄅ\u0000ᆯᆨ\u0000ᆯᆷ\u0000ᆯᆸ\u0000ᆯᆺ\u0000ᆯᇀ\u0000ᆯᇁ\u0000ᄅᄒ\u0000ᄆ\u0000ᄇ\u0000ᄇᄇ\u0000ᄇᄉ\u0000ᄉ\u0000ᄉᄉ\u0000ᄋ\u0000ᄌ\u0000ᄌᄌ\u0000ᄎ\u0000ᄏ\u0000ᄐ\u0000ᄑ\u0000ᄒ\u0000ᅡ\u0000ᅡᅵ\u0000ᅣ\u0000ᅣᅵ\u0000ᅥ\u0000ᅥᅵ\u0000ᅧ\u0000ᅧᅵ\u0000ᅩ\u0000ᅩᅡ\u0000ᅩᅵᅡ\u0000ᅩᅵ\u0000ᅭ\u0000ᅮ\u0000ᅮᅥ\u0000ᅮᅵᅥ\u0000ᅮᅵ\u0000ᅲ\u0000ᅳ\u0000ᅳᅵ\u0000ᅵ\u0000ᅠ\u0000ᄂᄂ\u0000ᄂᄃ\u0000ᆫᆺ\u0000ᆫᇫ\u0000ᆯᆺᆨ\u0000ᆯᆮ\u0000ᆯᆺᆸ\u0000ᆯᇫ\u0000ᆯᇹ\u0000ᄆᄇ\u0000ᆷᆺ\u0000ᆷᇫ\u0000ᄆᄋ\u0000ᄇᄀ\u0000ᄇᄃ\u0000ᄇᄀᄉ\u0000ᄇᄃᄉ\u0000ᄇᄌ\u0000ᄇᄐ\u0000ᄇᄋ\u0000ᄇᄋᄇ\u0000ᄉᄀ\u0000ᄉᄂ\u0000ᄉᄃ\u0000ᄉᄇ\u0000ᄉᄌ\u0000ᅀ\u0000ᄋᄋ\u0000ᅌ\u0000ᇰᆺ\u0000ᇰᇫ\u0000ᄑᄋ\u0000ᄒᄒ\u0000ᅙ\u0000ᅭᅣ\u0000ᅭᅵᅣ\u0000ᅭᅵ\u0000ᅲᅧ\u0000ᅲᅵᅧ\u0000ᅲᅵ\u0000ᆞ\u0000ᆞᅵ\u0000一\u0000二\u0000三\u0000四\u0000上\u0000中\u0000下\u0000甲\u0000乙\u0000丙\u0000丁\u0000天\u0000地\u0000人\u0000(ᄀ)\u0000(ᄂ)\u0000(ᄃ)\u0000(ᄅ)\u0000(ᄆ)\u0000(ᄇ)\u0000(ᄉ)\u0000(ᄋ)\u0000(ᄌ)\u0000(ᄎ)\u0000(ᄏ)\u0000(ᄐ)\u0000(ᄑ)\u0000(ᄒ)\u0000(가)\u0000(나)\u0000(다)\u0000(라)\u0000(마)\u0000(바)\u0000(사)\u0000(아)\u0000(자)\u0000(차)\u0000(카)\u0000(타)\u0000(파)\u0000(하)\u0000(주)\u0000(一)\u0000(二)\u0000(三)\u0000(四)\u0000(五)\u0000(六)\u0000(七)\u0000(八)\u0000(九)\u0000(十)\u0000(月)\u0000(火)\u0000(水)\u0000(木)\u0000(金)\u0000(土)\u0000(日)\u0000(株)\u0000(有)\u0000(社)\u0000(名)\u0000(特)\u0000(財)\u0000(祝)\u0000(労)\u0000(代)\u0000(呼)\u0000(学)\u0000(監)\u0000(企)\u0000(資)\u0000(協)\u0000(祭)\u0000(休)\u0000(自)\u0000(至)\u0000ᄀ\u0000ᄂ\u0000ᄃ\u0000ᄅ\u0000ᄆ\u0000ᄇ\u0000ᄉ\u0000ᄋ\u0000ᄌ\u0000ᄎ\u0000ᄏ\u0000ᄐ\u0000ᄑ\u0000ᄒ\u0000가\u0000나\u0000다\u0000라\u0000마\u0000바\u0000사\u0000아\u0000자\u0000차\u0000카\u0000타\u0000파\u0000하\u0000一\u0000二\u0000三\u0000四\u0000五\u0000六\u0000七\u0000八\u0000九\u0000十\u0000月\u0000火\u0000水\u0000木\u0000金\u0000土\u0000日\u0000株\u0000有\u0000社\u0000名\u0000特\u0000財\u0000祝\u0000労\u0000秘\u0000男\u0000女\u0000適\u0000優\u0000印\u0000注\u0000項\u0000休\u0000写\u0000正\u0000上\u0000中\u0000下\u0000左\u0000右\u0000医\u0000宗\u0000学\u0000監\u0000企\u0000資\u0000協\u0000夜\u00001月\u00002月\u00003月\u00004月\u00005月\u00006月\u00007月\u00008月\u00009月\u000010月\u000011月\u000012月\u0000ア\u0000イ\u0000ウ\u0000エ\u0000オ\u0000カ\u0000キ\u0000ク\u0000ケ\u0000コ\u0000サ\u0000シ\u0000ス\u0000セ\u0000ソ\u0000タ\u0000チ\u0000ツ\u0000テ\u0000ト\u0000ナ\u0000ニ\u0000ヌ\u0000ネ\u0000ノ\u0000ハ\u0000ヒ\u0000フ\u0000ヘ\u0000ホ\u0000マ\u0000ミ\u0000ム\u0000メ\u0000モ\u0000ヤ\u0000ユ\u0000ヨ\u0000ラ\u0000リ\u0000ル\u0000レ\u0000ロ\u0000ワ\u0000ヰ\u0000ヱ\u0000ヲ\u0000アパート\u0000アルファ\u0000アンペア\u0000アール\u0000イニング\u0000インチ\u0000ウォン\u0000エスクード\u0000エーカー\u0000オンス\u0000オーム\u0000カイリ\u0000カラット\u0000カロリー\u0000ガロン\u0000ガンマ\u0000ギガ\u0000ギニー\u0000キュリー\u0000ギルダー\u0000キロ\u0000キログラム\u0000キロメートル\u0000キロワット\u0000グラム\u0000グラムトン\u0000クルゼイロ\u0000クローネ\u0000ケース\u0000コルナ\u0000コーポ\u0000サイクル\u0000サンチーム\u0000シリング\u0000センチ\u0000セント\u0000ダース\u0000デシ\u0000ドル\u0000トン\u0000ナノ\u0000ノット\u0000ハイツ\u0000パーセント\u0000パーツ\u0000バーレル\u0000ピアストル\u0000ピクル\u0000ピコ\u0000ビル\u0000ファラッド\u0000フィート\u0000ブッシェル\u0000フラン\u0000ヘクタール\u0000ペソ\u0000ペニヒ\u0000ヘルツ\u0000ペンス\u0000ページ\u0000ベータ\u0000ポイント\u0000ボルト\u0000ホン\u0000ポンド\u0000ホール\u0000ホーン\u0000マイクロ\u0000マイル\u0000マッハ\u0000マルク\u0000マンション\u0000ミクロン\u0000ミリ\u0000ミリバール\u0000メガ\u0000メガトン\u0000メートル\u0000ヤード\u0000ヤール\u0000ユアン\u0000リットル\u0000リラ\u0000ルピー\u0000ルーブル\u0000レム\u0000レントゲン\u0000ワット\u00000点\u00001点\u00002点\u00003点\u00004点\u00005点\u00006点\u00007点\u00008点\u00009点\u000010点\u000011点\u000012点\u000013点\u000014点\u000015点\u000016点\u000017点\u000018点\u000019点\u000020点\u000021点\u000022点\u000023点\u000024点\u0000hPa\u0000da\u0000AU\u0000bar\u0000oV\u0000pc\u0000平成\u0000昭和\u0000大正\u0000明治\u0000株式会社\u0000pA\u0000nA\u0000μA\u0000mA\u0000kA\u0000KB\u0000MB\u0000GB\u0000cal\u0000kcal\u0000pF\u0000nF\u0000μF\u0000μg\u0000mg\u0000kg\u0000Hz\u0000kHz\u0000MHz\u0000GHz\u0000THz\u0000μl\u0000ml\u0000dl\u0000kl\u0000fm\u0000nm\u0000μm\u0000mm\u0000cm\u0000km\u0000mm2\u0000cm2\u0000m2\u0000km2\u0000mm3\u0000cm3\u0000m3\u0000km3\u0000m∕s\u0000m∕s2\u0000Pa\u0000kPa\u0000MPa\u0000GPa\u0000rad\u0000rad∕s\u0000rad∕s2\u0000ps\u0000ns\u0000μs\u0000ms\u0000pV\u0000nV\u0000μV\u0000mV\u0000kV\u0000MV\u0000pW\u0000nW\u0000μW\u0000mW\u0000kW\u0000MW\u0000kΩ\u0000MΩ\u0000a.m.\u0000Bq\u0000cc\u0000cd\u0000C∕kg\u0000Co.\u0000dB\u0000Gy\u0000ha\u0000HP\u0000in\u0000KK\u0000KM\u0000kt\u0000lm\u0000ln\u0000log\u0000lx\u0000mb\u0000mil\u0000mol\u0000PH\u0000p.m.\u0000PPM\u0000PR\u0000sr\u0000Sv\u0000Wb\u00001日\u00002日\u00003日\u00004日\u00005日\u00006日\u00007日\u00008日\u00009日\u000010日\u000011日\u000012日\u000013日\u000014日\u000015日\u000016日\u000017日\u000018日\u000019日\u000020日\u000021日\u000022日\u000023日\u000024日\u000025日\u000026日\u000027日\u000028日\u000029日\u000030日\u000031日\u0000ff\u0000fi\u0000fl\u0000ffi\u0000ffl\u0000st\u0000st\u0000մն\u0000մե\u0000մի\u0000վն\u0000մխ\u0000ײַ\u0000ע\u0000א\u0000ד\u0000ה\u0000כ\u0000ל\u0000ם\u0000ר\u0000ת\u0000+\u0000אל\u0000ٱ\u0000ٱ\u0000ٻ\u0000ٻ\u0000ٻ\u0000ٻ\u0000پ\u0000پ\u0000پ\u0000پ\u0000ڀ\u0000ڀ\u0000ڀ\u0000ڀ\u0000ٺ\u0000ٺ\u0000ٺ\u0000ٺ\u0000ٿ\u0000ٿ\u0000ٿ\u0000ٿ\u0000ٹ\u0000ٹ\u0000ٹ\u0000ٹ\u0000ڤ\u0000ڤ\u0000ڤ\u0000ڤ\u0000ڦ\u0000ڦ\u0000ڦ\u0000ڦ\u0000ڄ\u0000ڄ\u0000ڄ\u0000ڄ\u0000ڃ\u0000ڃ\u0000ڃ\u0000ڃ\u0000چ\u0000چ\u0000چ\u0000چ\u0000ڇ\u0000ڇ\u0000ڇ\u0000ڇ\u0000ڍ\u0000ڍ\u0000ڌ\u0000ڌ\u0000ڎ\u0000ڎ\u0000ڈ\u0000ڈ\u0000ژ\u0000ژ\u0000ڑ\u0000ڑ\u0000ک\u0000ک\u0000ک\u0000ک\u0000گ\u0000گ\u0000گ\u0000گ\u0000ڳ\u0000ڳ\u0000ڳ\u0000ڳ\u0000ڱ\u0000ڱ\u0000ڱ\u0000ڱ\u0000ں\u0000ں\u0000ڻ\u0000ڻ\u0000ڻ\u0000ڻ\u0000ۀ\u0000ۀ\u0000ہ\u0000ہ\u0000ہ\u0000ہ\u0000ھ\u0000ھ\u0000ھ\u0000ھ\u0000ے\u0000ے\u0000ۓ\u0000ۓ\u0000ڭ\u0000ڭ\u0000ڭ\u0000ڭ\u0000ۇ\u0000ۇ\u0000ۆ\u0000ۆ\u0000ۈ\u0000ۈ\u0000ٷ\u0000ۋ\u0000ۋ\u0000ۅ\u0000ۅ\u0000ۉ\u0000ۉ\u0000ې\u0000ې\u0000ې\u0000ې\u0000ی\u0000ی\u0000ی\u0000ی\u0000..\u0000—\u0000–\u0000 ̲\u0000 ̲\u0000(\u0000)\u0000{\u0000}\u0000〔\u0000〕\u0000【\u0000】\u0000《\u0000》\u0000〈\u0000〉\u0000「\u0000」\u0000『\u0000』\u0000 ̅\u0000 ̅\u0000 ̅\u0000 ̅\u0000 ̲\u0000 ̲\u0000 ̲\u0000,\u0000、\u0000.\u0000;\u0000:\u0000?\u0000!\u0000—\u0000(\u0000)\u0000{\u0000}\u0000〔\u0000〕\u0000#\u0000&\u0000*\u0000+\u0000-\u0000<\u0000>\u0000=\u0000\\\u0000$\u0000%\u0000@\u0000 ً\u0000ـً\u0000 ٌ\u0000 ٍ\u0000 َ\u0000ـَ\u0000 ُ\u0000ـُ\u0000 ِ\u0000ـِ\u0000 ّ\u0000ـّ\u0000 ْ\u0000ـْ\u0000ء\u0000آ\u0000آ\u0000أ\u0000أ\u0000ؤ\u0000ؤ\u0000إ\u0000إ\u0000ئ\u0000ئ\u0000ئ\u0000ئ\u0000ا\u0000ا\u0000ب\u0000ب\u0000ب\u0000ب\u0000ة\u0000ة\u0000ت\u0000ت\u0000ت\u0000ت\u0000ث\u0000ث\u0000ث\u0000ث\u0000ج\u0000ج\u0000ج\u0000ج\u0000ح\u0000ح\u0000ح\u0000ح\u0000خ\u0000خ\u0000خ\u0000خ\u0000د\u0000د\u0000ذ\u0000ذ\u0000ر\u0000ر\u0000ز\u0000ز\u0000س\u0000س\u0000س\u0000س\u0000ش\u0000ش\u0000ش\u0000ش\u0000ص\u0000ص\u0000ص\u0000ص\u0000ض\u0000ض\u0000ض\u0000ض\u0000ط\u0000ط\u0000ط\u0000ط\u0000ظ\u0000ظ\u0000ظ\u0000ظ\u0000ع\u0000ع\u0000ع\u0000ع\u0000غ\u0000غ\u0000غ\u0000غ\u0000ف\u0000ف\u0000ف\u0000ف\u0000ق\u0000ق\u0000ق\u0000ق\u0000ك\u0000ك\u0000ك\u0000ك\u0000ل\u0000ل\u0000ل\u0000ل\u0000م\u0000م\u0000م\u0000م\u0000ن\u0000ن\u0000ن\u0000ن\u0000ه\u0000ه\u0000ه\u0000ه\u0000و\u0000و\u0000ى\u0000ى\u0000ي\u0000ي\u0000ي\u0000ي\u0000!\u0000\"\u0000#\u0000$\u0000%\u0000&\u0000'\u0000(\u0000)\u0000*\u0000+\u0000,\u0000-\u0000.\u0000/\u00000\u00001\u00002\u00003\u00004\u00005\u00006\u00007\u00008\u00009\u0000:\u0000;\u0000<\u0000=\u0000>\u0000?\u0000@\u0000A\u0000B\u0000C\u0000D\u0000E\u0000F\u0000G\u0000H\u0000I\u0000J\u0000K\u0000L\u0000M\u0000N\u0000O\u0000P\u0000Q\u0000R\u0000S\u0000T\u0000U\u0000V\u0000W\u0000X\u0000Y\u0000Z\u0000[\u0000\\\u0000]\u0000 ̂\u0000 ̲\u0000 ̀\u0000a\u0000b\u0000c\u0000d\u0000e\u0000f\u0000g\u0000h\u0000i\u0000j\u0000k\u0000l\u0000m\u0000n\u0000o\u0000p\u0000q\u0000r\u0000s\u0000t\u0000u\u0000v\u0000w\u0000x\u0000y\u0000z\u0000{\u0000|\u0000}\u0000~\u0000。\u0000「\u0000」\u0000、\u0000・\u0000ヲ\u0000ァ\u0000ィ\u0000ゥ\u0000ェ\u0000ォ\u0000ャ\u0000ュ\u0000ョ\u0000ッ\u0000ー\u0000ア\u0000イ\u0000ウ\u0000エ\u0000オ\u0000カ\u0000キ\u0000ク\u0000ケ\u0000コ\u0000サ\u0000シ\u0000ス\u0000セ\u0000ソ\u0000タ\u0000チ\u0000ツ\u0000テ\u0000ト\u0000ナ\u0000ニ\u0000ヌ\u0000ネ\u0000ノ\u0000ハ\u0000ヒ\u0000フ\u0000ヘ\u0000ホ\u0000マ\u0000ミ\u0000ム\u0000メ\u0000モ\u0000ヤ\u0000ユ\u0000ヨ\u0000ラ\u0000リ\u0000ル\u0000レ\u0000ロ\u0000ワ\u0000ン\u0000 ゙\u0000 ゚\u0000ᅠ\u0000ᄀ\u0000ᄀᄀ\u0000ᆨᆺ\u0000ᄂ\u0000ᆫᆽ\u0000ᆫᇂ\u0000ᄃ\u0000ᄃᄃ\u0000ᄅ\u0000ᆯᆨ\u0000ᆯᆷ\u0000ᆯᆸ\u0000ᆯᆺ\u0000ᆯᇀ\u0000ᆯᇁ\u0000ᄅᄒ\u0000ᄆ\u0000ᄇ\u0000ᄇᄇ\u0000ᄇᄉ\u0000ᄉ\u0000ᄉᄉ\u0000ᄋ\u0000ᄌ\u0000ᄌᄌ\u0000ᄎ\u0000ᄏ\u0000ᄐ\u0000ᄑ\u0000ᄒ\u0000ᅡ\u0000ᅡᅵ\u0000ᅣ\u0000ᅣᅵ\u0000ᅥ\u0000ᅥᅵ\u0000ᅧ\u0000ᅧᅵ\u0000ᅩ\u0000ᅩᅡ\u0000ᅩᅡᅵ\u0000ᅩᅵ\u0000ᅭ\u0000ᅮ\u0000ᅮᅥ\u0000ᅮᅥᅵ\u0000ᅮᅵ\u0000ᅲ\u0000ᅳ\u0000ᅳᅵ\u0000ᅵ\u0000¢\u0000£\u0000¬\u0000 ̄\u0000¦\u0000¥\u0000₩\u0000│\u0000←\u0000↑\u0000→\u0000↓\u0000■\u0000○\u0000Fr\u0000";
   private static int maximumDecomposition = 7589;
   private static int maximumCanonical = 3200;
   private String str;
   private int getBeginIndex;
   private int getEndIndex;
   private int decmpMode;
   private int decmpLimit;
   private int sIndex;
   private StringBuffer parsedStr;
   private int pIndex;
   private boolean backedUp;
   private boolean decomposing;
   private char prevChar;
   private static final CompactShortArray startOffsets;
   static final byte BASE = -128;
   static final CompactByteArray canonicals;

   public DecompositionIterator(String var1, int var2, int var3, int var4) {
      this.backedUp = false;
      this.decomposing = false;
      this.prevChar = '\uffff';
      this.str = var1;
      this.getBeginIndex = var2;
      this.getEndIndex = var3;
      this.sIndex = var2;
      this.decmpMode = var4;
      this.decmpLimit = var4 == 1 ? maximumCanonical : 32767;
      this.parsedStr = null;
      this.pIndex = 0;
      this.backedUp = false;
   }

   public DecompositionIterator(String var1, int var2) {
      this(var1, 0, var1.length(), var2);
   }

   public void setDecomposition(int var1) {
      this.decmpMode = var1;
   }

   public void setText(String var1) {
      this.str = var1;
      this.parsedStr.setLength(0);
      this.sIndex = 0;
      this.pIndex = 0;
      this.getBeginIndex = 0;
      this.getEndIndex = var1.length();
   }

   public char next() {
      int var2 = 0;
      char var3;
      if (this.backedUp) {
         var3 = this.prevChar;
         this.backedUp = false;
      } else if (this.decmpMode == 0) {
         var3 = this.sIndex < this.getEndIndex ? this.str.charAt(this.sIndex++) : '\uffff';
      } else if (this.decomposing) {
         var3 = this.parsedStr.charAt(this.pIndex++);
         if (this.pIndex >= this.parsedStr.length()) {
            this.decomposing = false;
         }
      } else if (this.sIndex >= this.getEndIndex) {
         var3 = '\uffff';
      } else {
         char var1 = this.str.charAt(this.sIndex++);
         var2 = startOffsets.elementAt(var1);
         if (var2 >= this.decmpLimit && canonicals.elementAt(var1) == -128) {
            var3 = var1;
         } else {
            if (this.parsedStr == null) {
               this.parsedStr = new StringBuffer();
            } else {
               this.parsedStr.setLength(0);
            }

            if (var2 < this.decmpLimit) {
               while((var1 = contents.charAt(var2++)) != 0) {
                  this.parsedStr.append(var1);
               }
            } else {
               this.parsedStr.append(var1);
            }

            while(this.sIndex < this.getEndIndex && canonicals.elementAt(var1 = this.str.charAt(this.sIndex)) != -128) {
               this.parsedStr.append(var1);
               ++this.sIndex;
            }

            if (this.parsedStr.length() > 1) {
               fixCanonical(this.parsedStr);
               this.pIndex = 1;
               this.decomposing = true;
            } else {
               this.decomposing = false;
            }

            var3 = this.parsedStr.charAt(0);
         }
      }

      this.prevChar = var3;
      return var3;
   }

   public char previous() {
      this.backedUp = true;
      return this.prevChar;
   }

   public void reset() {
      this.sIndex = this.getBeginIndex;
      this.pIndex = 0;
      this.decomposing = false;
      this.backedUp = false;
   }

   final void setOffset(int var1) {
      if (this.getBeginIndex <= var1 && var1 < this.getEndIndex) {
         this.sIndex = var1;
         this.pIndex = 0;
         this.decomposing = false;
         this.backedUp = false;
      } else {
         throw new IndexOutOfBoundsException("DecompositionIterator new offset out of bounds.");
      }
   }

   final int getOffset() {
      return this.sIndex;
   }

   public int getDecomposition() {
      return this.decmpMode;
   }

   static String decompose(char var0, int var1) {
      if (var1 == 0) {
         StringBuffer var6 = new StringBuffer();
         var6.append(var0);
         return var6.toString();
      } else {
         int var2 = var1 == 1 ? maximumCanonical : 32767;
         int var3 = startOffsets.elementAt(var0);
         if (var3 >= var2) {
            return "";
         } else {
            StringBuffer var4 = new StringBuffer();

            while(true) {
               char var5 = contents.charAt(var3++);
               if (var5 == 0) {
                  fixCanonical(var4);
                  return var4.toString();
               }

               var4.append(var5);
            }
         }
      }
   }

   static void decompose(StringBuffer var0, int var1) {
      byte var2 = 0;
      int var3 = var0.length();
      if (var1 == 0) {
         String var4 = var0.toString().substring(var2, var3);
         var0.setLength(0);
         var0.append(var4);
      }

      int var9 = var1 == 1 ? maximumCanonical : 32767;
      StringBuffer var5 = new StringBuffer();

      for(int var6 = var2; var6 < var3; ++var6) {
         char var7 = var0.charAt(var6);
         int var8 = startOffsets.elementAt(var7);
         if (var8 >= var9) {
            var5.append(var7);
         } else {
            while(true) {
               var7 = contents.charAt(var8++);
               if (var7 == 0) {
                  break;
               }

               var5.append(var7);
            }
         }
      }

      var0.setLength(0);
      var0.append(var5.toString());
   }

   static String decompose(String var0, int var1) {
      byte var2 = 0;
      int var3 = var0.length();
      if (var1 == 0) {
         return var0.substring(var2, var3);
      } else {
         int var4 = var1 == 1 ? maximumCanonical : 32767;
         StringBuffer var5 = new StringBuffer();

         for(int var6 = var2; var6 < var3; ++var6) {
            char var7 = var0.charAt(var6);
            int var8 = startOffsets.elementAt(var7);
            if (var8 >= var4) {
               var5.append(var7);
            } else {
               while(true) {
                  var7 = contents.charAt(var8++);
                  if (var7 == 0) {
                     break;
                  }

                  var5.append(var7);
               }
            }
         }

         return var5.toString();
      }
   }

   static int getMaximumDecomposition() {
      return maximumDecomposition;
   }

   private static void fixCanonical(StringBuffer var0) {
      int var1 = var0.length() - 1;
      byte var3 = canonicals.elementAt(var0.charAt(var1));
      --var1;

      for(; var1 >= 0; --var1) {
         byte var2 = var3;
         var3 = canonicals.elementAt(var0.charAt(var1));
         if (var3 > var2 && var2 != -128) {
            char var4 = var0.charAt(var1);
            var0.setCharAt(var1, var0.charAt(var1 + 1));
            var0.setCharAt(var1 + 1, var4);
            if (var1 < var0.length() - 2) {
               var1 += 2;
            }

            var3 = canonicals.elementAt(var0.charAt(var1));
         }
      }

   }

   static {
      startOffsets = new CompactShortArray(kOffsetIndex, kOffsetValues);
      canonicals = new CompactByteArray(kCanonicalIndex, kCanonicalValues);
   }
}
