package java.text;

final class LineBreakData extends TextBoundaryData {
   private static final byte BREAK = 0;
   private static final byte blank = 1;
   // $FF: renamed from: cr byte
   private static final byte field_0 = 2;
   private static final byte nonBlank = 3;
   // $FF: renamed from: op byte
   private static final byte field_1 = 4;
   private static final byte jwrd = 5;
   private static final byte preJwrd = 6;
   private static final byte postJwrd = 7;
   private static final byte digit = 8;
   private static final byte numPunct = 9;
   private static final byte currency = 10;
   private static final byte nsm = 11;
   private static final byte nbsp = 12;
   private static final byte EOS = 13;
   private static final int COL_COUNT = 14;
   // $FF: renamed from: SI byte
   private static final byte field_2 = -128;
   private static final byte STOP = 0;
   private static final byte SI_STOP = -128;
   private static final byte[] kLineForwardData = new byte[]{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -124, -126, -121, -125, -122, -123, -127, -120, -119, -120, -127, -127, -127, -128, -124, -126, -121, -128, -128, -128, -128, -128, -128, -128, -128, -126, -127, -128, -124, -126, -121, -125, -122, -128, -128, -120, -119, -120, -128, -125, -127, -128, -128, -128, -128, -128, -128, -128, -128, -128, -128, -128, -128, -128, -128, -128, -124, -126, -121, -128, -128, -128, -128, -120, -128, -120, -128, -123, -127, -128, -124, -128, -121, -128, -128, -128, -128, -128, -119, -128, -117, -122, -127, -128, -124, -128, -128, -128, -128, -128, -128, -128, -128, -128, -128, -128, -128, -128, -124, -126, -121, -128, -128, -128, -128, -120, -128, -120, -128, -120, -127, -128, -124, -126, -121, -125, -122, -128, -128, -120, -119, -118, -118, -119, -127, -128, -124, -126, -121, -128, -128, -128, -128, -120, -119, -120, -128, -118, -127, -128, 0, 0, 0, 0, 0, 0, 0, 0, -119, 0, 0, 11, -127, 0};
   private static final WordBreakTable kLineForward;
   private static final byte[] kLineBackwardData;
   private static final WordBreakTable kLineBackward;
   private static final int[] kRawMapping;
   private static SpecialMapping[] kExceptionChar;
   private static final boolean[] LineExceptionFlags;
   private static final int[] kLineAsciiValues;
   private static final UnicodeClassMapping kLineMap;

   public WordBreakTable forward() {
      return kLineForward;
   }

   public WordBreakTable backward() {
      return kLineBackward;
   }

   public UnicodeClassMapping map() {
      return kLineMap;
   }

   static {
      kLineForward = new WordBreakTable(14, kLineForwardData);
      kLineBackwardData = new byte[]{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -127, -127, -127, -126, -126, -124, -126, -125, -126, -125, -126, -127, -126, 0, 0, 0, 0, -126, -126, 0, -126, -125, -126, -125, -126, -126, -126, 0, 0, 0, 0, -126, 0, -124, -126, -125, -126, -125, -126, -125, -126, 0, 0, 0, 0, 0, 0, 0, -126, 0, 0, 0, -126, -124, -124, 0};
      kLineBackward = new WordBreakTable(14, kLineBackwardData);
      kRawMapping = new int[]{3, 3, 3, 3, 3, 3, 11, 11, 3, 8, 3, 8, 1, 1, 1, 1, 3, 3, 3, 3, 4, 6, 7, 3, 3, 3, 6, 3, 3};
      kExceptionChar = new SpecialMapping[]{new SpecialMapping('\u0003', 0), new SpecialMapping('\t', '\f', 0), new SpecialMapping('\r', 2), new SpecialMapping('!', 7), new SpecialMapping('$', 6), new SpecialMapping('%', 7), new SpecialMapping(',', 9), new SpecialMapping('.', 9), new SpecialMapping(':', ';', 7), new SpecialMapping('?', 7), new SpecialMapping(' ', 12), new SpecialMapping('¢', 7), new SpecialMapping('\u00ad', 4), new SpecialMapping('°', 7), new SpecialMapping('٪', 7), new SpecialMapping(' ', 12), new SpecialMapping('‑', 12), new SpecialMapping('\u2028', '\u2029', 0), new SpecialMapping('‰', 7), new SpecialMapping('‱', 7), new SpecialMapping('′', '‴', 7), new SpecialMapping('℃', 7), new SpecialMapping('℉', 7), new SpecialMapping('、', '。', 7), new SpecialMapping('々', 7), new SpecialMapping('ぁ', 7), new SpecialMapping('あ', 5), new SpecialMapping('ぃ', 7), new SpecialMapping('い', 5), new SpecialMapping('ぅ', 7), new SpecialMapping('う', 5), new SpecialMapping('ぇ', 7), new SpecialMapping('え', 5), new SpecialMapping('ぉ', 7), new SpecialMapping('お', 'ぢ', 5), new SpecialMapping('っ', 7), new SpecialMapping('つ', 'も', 5), new SpecialMapping('ゃ', 7), new SpecialMapping('や', 5), new SpecialMapping('ゅ', 7), new SpecialMapping('ゆ', 5), new SpecialMapping('ょ', 7), new SpecialMapping('よ', 'ろ', 5), new SpecialMapping('ゎ', 7), new SpecialMapping('わ', 'ゔ', 5), new SpecialMapping('゙', '゜', 7), new SpecialMapping('ゝ', 'ゞ', 7), new SpecialMapping('ァ', 7), new SpecialMapping('ア', 5), new SpecialMapping('ィ', 7), new SpecialMapping('イ', 5), new SpecialMapping('ゥ', 7), new SpecialMapping('ウ', 5), new SpecialMapping('ェ', 7), new SpecialMapping('エ', 5), new SpecialMapping('ォ', 7), new SpecialMapping('オ', 'ヂ', 5), new SpecialMapping('ッ', 7), new SpecialMapping('ツ', 'モ', 5), new SpecialMapping('ャ', 7), new SpecialMapping('ヤ', 5), new SpecialMapping('ュ', 7), new SpecialMapping('ユ', 5), new SpecialMapping('ョ', 7), new SpecialMapping('ヨ', 'ロ', 5), new SpecialMapping('ヮ', 7), new SpecialMapping('ワ', 'ヴ', 5), new SpecialMapping('ヵ', 'ヶ', 7), new SpecialMapping('ヷ', 'ヺ', 5), new SpecialMapping('ー', 7), new SpecialMapping('ヽ', 'ヾ', 7), new SpecialMapping('一', '龥', 5), new SpecialMapping('豈', '鶴', 5), new SpecialMapping('\ufeff', 12), new SpecialMapping('\uffff', 13)};
      LineExceptionFlags = new boolean[]{false, false, false, false, true, true, true, false, false, false, false, false, true, true, true, true, true, false, false, false, true, false, false, false, true, false, true, false, true};
      kLineAsciiValues = new int[]{1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 7, 3, 3, 10, 7, 3, 3, 6, 7, 3, 3, 9, 4, 9, 3, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 7, 7, 3, 3, 3, 7, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 6, 3, 7, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 6, 3, 7, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 12, 3, 7, 10, 10, 10, 3, 3, 3, 3, 3, 6, 3, 4, 3, 3, 7, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 7, 8, 8, 8, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3};
      kLineMap = new UnicodeClassMapping(kRawMapping, kExceptionChar, LineExceptionFlags, kLineAsciiValues);
   }
}
