package java.text;

final class SentenceBreakData extends TextBoundaryData {
   private static final byte other = 0;
   private static final byte space = 1;
   private static final byte terminator = 2;
   private static final byte ambiguosTerm = 3;
   private static final byte openBracket = 4;
   private static final byte closeBracket = 5;
   private static final byte cjk = 6;
   private static final byte paragraphBreak = 7;
   private static final byte lowerCase = 8;
   private static final byte upperCase = 9;
   private static final byte number = 10;
   private static final byte quote = 11;
   private static final byte sent_cr = 12;
   private static final byte nsm = 13;
   private static final byte EOS = 14;
   private static final int COL_COUNT = 15;
   // $FF: renamed from: SI byte
   private static final byte field_0 = -128;
   private static final byte STOP = 0;
   private static final byte SI_STOP = -128;
   private static final byte[] kSentenceForwardData = new byte[]{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -127, -127, -126, -123, -127, -127, -127, -124, -127, -120, -119, -127, -118, -127, -128, -128, -125, -126, -123, -127, -126, -128, -124, -128, -128, -128, -126, -118, -126, -128, -128, -125, -128, -128, -128, -128, -128, -124, -128, -128, -128, -128, -118, -125, -128, -128, -128, -128, -128, -128, -128, -128, -128, -128, -128, -128, -128, -128, -128, -128, -128, -122, -126, -123, -127, -123, -128, -124, -127, -128, -128, -123, -118, -123, -128, -128, -122, -128, -128, -121, -127, -128, -124, -127, -128, -127, -128, -118, -122, -128, -128, -128, -128, -128, 7, -128, -128, -128, -127, 0, -128, -128, -128, -121, -128, -127, -127, -126, -120, -127, -123, -128, -124, -127, -120, -119, -123, -118, -120, -128, -127, -127, -126, -119, -127, -123, -128, -124, -127, -127, -119, -123, -118, -119, -128, -128, -128, -128, -128, -128, -128, -128, -124, -128, -128, -128, -128, -128, -128, -128};
   private static final WordBreakTable kSentenceForward;
   private static final byte[] kSentenceBackwardData;
   private static final WordBreakTable kSentenceBackward;
   private static final int[] kRawMapping;
   private static SpecialMapping[] kExceptionChar;
   private static final boolean[] SentenceExceptionFlags;
   private static final int[] kSentenceAsciiValues;
   private static final UnicodeClassMapping kSentenceMap;

   public WordBreakTable forward() {
      return kSentenceForward;
   }

   public WordBreakTable backward() {
      return kSentenceBackward;
   }

   public UnicodeClassMapping map() {
      return kSentenceMap;
   }

   static {
      kSentenceForward = new WordBreakTable(15, kSentenceForwardData);
      kSentenceBackwardData = new byte[]{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -126, -126, -126, -126, -126, -126, -125, 0, -126, -125, -126, -126, -126, -127, 0, -126, -126, -126, -126, -126, -126, -125, 0, -126, -125, -126, -126, 0, -126, 0, -126, -124, -126, -126, -126, -126, -125, 0, -125, -126, -126, -126, 0, -125, 0, -126, -124, -128, -128, -126, -126, -125, 0, -126, -125, -126, -126, 0, -124, 0};
      kSentenceBackward = new WordBreakTable(15, kSentenceBackwardData);
      kRawMapping = new int[]{0, 9, 8, 0, 0, 0, 13, 13, 0, 10, 10, 10, 1, 1, 1, 0, 0, 0, 0, 0, 0, 4, 5, 0, 0, 0, 0, 0, 0};
      kExceptionChar = new SpecialMapping[]{new SpecialMapping('\t', 1), new SpecialMapping('\n', 1), new SpecialMapping('\f', 2), new SpecialMapping('\r', 1), new SpecialMapping('!', 2), new SpecialMapping('"', 11), new SpecialMapping('\'', 11), new SpecialMapping('.', 3), new SpecialMapping('?', 2), new SpecialMapping(' ', 0), new SpecialMapping('\u2028', 1), new SpecialMapping('\u2029', 7), new SpecialMapping('。', 2), new SpecialMapping('ぁ', 'ゔ', 6), new SpecialMapping('゙', '゜', 6), new SpecialMapping('ァ', 'ヶ', 6), new SpecialMapping('一', '龥', 6), new SpecialMapping('豈', '鶴', 6), new SpecialMapping('\ufeff', 0), new SpecialMapping('\uffff', 14)};
      SentenceExceptionFlags = new boolean[]{false, false, false, false, false, true, true, false, false, false, false, false, true, true, true, true, true, false, false, false, false, false, false, false, true, false, false, false, false};
      kSentenceAsciiValues = new int[]{0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 11, 0, 0, 0, 0, 11, 4, 5, 0, 0, 0, 0, 3, 0, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 0, 0, 0, 0, 0, 2, 0, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 4, 0, 5, 0, 0, 0, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 4, 0, 5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8, 4, 0, 0, 0, 0, 0, 0, 10, 10, 0, 8, 0, 0, 0, 8, 0, 5, 10, 10, 10, 0, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 0, 9, 9, 9, 9, 9, 9, 9, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 0, 8, 8, 8, 8, 8, 8, 8, 8};
      kSentenceMap = new UnicodeClassMapping(kRawMapping, kExceptionChar, SentenceExceptionFlags, kSentenceAsciiValues);
   }
}
