package java.text;

abstract class TextBoundaryData {
   protected static final char ASCII_END_OF_TEXT = '\u0003';
   protected static final char ASCII_HORIZONTAL_TABULATION = '\t';
   protected static final char ASCII_LINEFEED = '\n';
   protected static final char ASCII_VERTICAL_TABULATION = '\u000b';
   protected static final char ASCII_FORM_FEED = '\f';
   protected static final char ASCII_CARRIAGE_RETURN = '\r';
   protected static final char ASCII_SPACE = ' ';
   protected static final char ASCII_EXCLAMATION_MARK = '!';
   protected static final char ASCII_QUOTATION_MARK = '"';
   protected static final char ASCII_NUMBER_SIGN = '#';
   protected static final char ASCII_DOLLAR_SIGN = '$';
   protected static final char ASCII_PERCENT = '%';
   protected static final char ASCII_AMPERSAND = '&';
   protected static final char ASCII_APOSTROPHE = '\'';
   protected static final char ASCII_COMMA = ',';
   protected static final char ASCII_FULL_STOP = '.';
   protected static final char ASCII_COLON = ':';
   protected static final char ASCII_SEMICOLON = ';';
   protected static final char ASCII_QUESTION_MARK = '?';
   protected static final char ASCII_NONBREAKING_SPACE = ' ';
   protected static final char ASCII_CENT_SIGN = '¢';
   protected static final char ASCII_POUND_SIGN = '£';
   protected static final char ASCII_YEN_SIGN = '¥';
   protected static final char LATIN1_SOFTHYPHEN = '\u00ad';
   protected static final char LATIN1_DEGREE_SIGN = '°';
   protected static final char ARABIC_PERCENT_SIGN = '٪';
   protected static final char ARABIC_DECIMAL_SEPARATOR = '٫';
   protected static final char HANGUL_CHOSEONG_LOW = 'ᄀ';
   protected static final char HANGUL_CHOSEONG_HIGH = 'ᅟ';
   protected static final char HANGUL_JUNGSEONG_LOW = 'ᅠ';
   protected static final char HANGUL_JUNGSEONG_HIGH = 'ᆧ';
   protected static final char HANGUL_JONGSEONG_LOW = 'ᆨ';
   protected static final char HANGUL_JONGSEONG_HIGH = 'ᇿ';
   protected static final char FIGURE_SPACE = ' ';
   protected static final char NONBREAKING_HYPHEN = '‑';
   protected static final char PUNCTUATION_HYPHENATION_POINT = '‧';
   protected static final char PUNCTUATION_LINE_SEPARATOR = '\u2028';
   protected static final char PUNCTUATION_PARAGRAPH_SEPARATOR = '\u2029';
   protected static final char PER_MILLE_SIGN = '‰';
   protected static final char PER_TEN_THOUSAND_SIGN = '‱';
   protected static final char PRIME = '′';
   protected static final char DOUBLE_PRIME = '″';
   protected static final char TRIPLE_PRIME = '‴';
   protected static final char DEGREE_CELSIUS = '℃';
   protected static final char DEGREE_FAHRENHEIT = '℉';
   protected static final char PUNCTUATION_IDEOGRAPHIC_COMMA = '、';
   protected static final char PUNCTUATION_IDEOGRAPHIC_FULL_STOP = '。';
   protected static final char IDEOGRAPHIC_ITERATION_MARK = '々';
   protected static final char HIRAGANA_LETTER_SMALL_A = 'ぁ';
   protected static final char HIRAGANA_LETTER_A = 'あ';
   protected static final char HIRAGANA_LETTER_SMALL_I = 'ぃ';
   protected static final char HIRAGANA_LETTER_I = 'い';
   protected static final char HIRAGANA_LETTER_SMALL_U = 'ぅ';
   protected static final char HIRAGANA_LETTER_U = 'う';
   protected static final char HIRAGANA_LETTER_SMALL_E = 'ぇ';
   protected static final char HIRAGANA_LETTER_E = 'え';
   protected static final char HIRAGANA_LETTER_SMALL_O = 'ぉ';
   protected static final char HIRAGANA_LETTER_O = 'お';
   protected static final char HIRAGANA_LETTER_DI = 'ぢ';
   protected static final char HIRAGANA_LETTER_SMALL_TU = 'っ';
   protected static final char HIRAGANA_LETTER_TU = 'つ';
   protected static final char HIRAGANA_LETTER_MO = 'も';
   protected static final char HIRAGANA_LETTER_SMALL_YA = 'ゃ';
   protected static final char HIRAGANA_LETTER_YA = 'や';
   protected static final char HIRAGANA_LETTER_SMALL_YU = 'ゅ';
   protected static final char HIRAGANA_LETTER_YU = 'ゆ';
   protected static final char HIRAGANA_LETTER_SMALL_YO = 'ょ';
   protected static final char HIRAGANA_LETTER_YO = 'よ';
   protected static final char HIRAGANA_LETTER_RO = 'ろ';
   protected static final char HIRAGANA_LETTER_SMALL_WA = 'ゎ';
   protected static final char HIRAGANA_LETTER_WA = 'わ';
   protected static final char HIRAGANA_LETTER_VU = 'ゔ';
   protected static final char COMBINING_KATAKANA_HIRAGANA_VOICED_SOUND_MARK = '゙';
   protected static final char HIRAGANA_SEMIVOICED_SOUND_MARK = '゜';
   protected static final char HIRAGANA_ITERATION_MARK = 'ゝ';
   protected static final char HIRAGANA_VOICED_ITERATION_MARK = 'ゞ';
   protected static final char KATAKANA_LETTER_SMALL_A = 'ァ';
   protected static final char KATAKANA_LETTER_A = 'ア';
   protected static final char KATAKANA_LETTER_SMALL_I = 'ィ';
   protected static final char KATAKANA_LETTER_I = 'イ';
   protected static final char KATAKANA_LETTER_SMALL_U = 'ゥ';
   protected static final char KATAKANA_LETTER_U = 'ウ';
   protected static final char KATAKANA_LETTER_SMALL_E = 'ェ';
   protected static final char KATAKANA_LETTER_E = 'エ';
   protected static final char KATAKANA_LETTER_SMALL_O = 'ォ';
   protected static final char KATAKANA_LETTER_O = 'オ';
   protected static final char KATAKANA_LETTER_DI = 'ヂ';
   protected static final char KATAKANA_LETTER_SMALL_TU = 'ッ';
   protected static final char KATAKANA_LETTER_TU = 'ツ';
   protected static final char KATAKANA_LETTER_MO = 'モ';
   protected static final char KATAKANA_LETTER_SMALL_YA = 'ャ';
   protected static final char KATAKANA_LETTER_YA = 'ヤ';
   protected static final char KATAKANA_LETTER_SMALL_YU = 'ュ';
   protected static final char KATAKANA_LETTER_YU = 'ユ';
   protected static final char KATAKANA_LETTER_SMALL_YO = 'ョ';
   protected static final char KATAKANA_LETTER_YO = 'ヨ';
   protected static final char KATAKANA_LETTER_RO = 'ロ';
   protected static final char KATAKANA_LETTER_SMALL_WA = 'ヮ';
   protected static final char KATAKANA_LETTER_WA = 'ワ';
   protected static final char KATAKANA_LETTER_VU = 'ヴ';
   protected static final char KATAKANA_LETTER_SMALL_KA = 'ヵ';
   protected static final char KATAKANA_LETTER_SMALL_KE = 'ヶ';
   protected static final char KATAKANA_LETTER_VA = 'ヷ';
   protected static final char KATAKANA_LETTER_VO = 'ヺ';
   protected static final char KATAKANA_HIRAGANA_PROLONGED_SOUND_MARK = 'ー';
   protected static final char KATAKANA_ITERATION_MARK = 'ヽ';
   protected static final char KATAKANA_VOICED_ITERATION_MARK = 'ヾ';
   protected static final char UNICODE_LOW_BOUND_HAN = '一';
   protected static final char UNICODE_HIGH_BOUND_HAN = '龥';
   protected static final char HANGUL_SYL_LOW = '가';
   protected static final char HANGUL_SYL_HIGH = '힣';
   protected static final char CJK_COMPATIBILITY_F900 = '豈';
   protected static final char CJK_COMPATIBILITY_FA2D = '鶴';
   protected static final char UNICODE_ZERO_WIDTH_NON_BREAKING_SPACE = '\ufeff';
   protected static final char END_OF_STRING = '\uffff';

   public abstract WordBreakTable forward();

   public abstract WordBreakTable backward();

   public abstract UnicodeClassMapping map();
}
